'This BMX file was edited with BLIde ( http://www.blide.org )

rem
	bbdoc: A collection of some usefull functions
end rem

Function setIntColor(color:Int)
	SetAlpha ((color & $ff000000) Shr 24) / Float($ff)
	SetColor (color & $ff0000) Shr 16, (color & $ff00) Shr 8, (color & $ff)
End Function


rem
	bbdoc: Draws a line from x0,y0 to x1,y1 using the specified image. Note: image should be centered around the x-axis. y-handle should be 0.
end rem
Function DrawImageLine(image:TImage, x0:Double, y0:Double, x1:Double, y1:Double)
	Local dx:Double = x1 - x0
	Local dy:Double = y1 - y0
	Local dist:Double = Sqr(dx * dx + dy * dy)
	dx:/dist
	dy:/dist
	SetRotation(ATan2(dx, -dy))
	
	
	For Local i:Int = image.height Until dist
		DrawImage image, x0 + i * dx, y0 + i * dy
		i:+image.height - 1
	Next
	SetRotation 0
End Function


Function distance:Double(x0:Double, y0:Double, x1:Double, y1:Double)
	Return Sqr((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0))
End Function
