'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TGuiTextbox Extends TGuiObject
	Field text:String
	Field textlines:TList = New TList
	Field lineheight:Int
	Field textcolor:Int = $ffffffff
	Field textshadow:Byte = True
	Field textshadowcolor:Int = $88000000
	Field textGravityHorizontal:Float '0 = left, 0.5 = middle, 1 = right
	
	Field drawrectbox:Byte = False
	Field rectboxcolor:Int = $ff000000
	
	Rem
		bbdoc: Get the text value in this TGuiTextbox object.
	End Rem
	Method Gettext:String()
		Return text
	End Method
	Rem
		bbdoc: Set the text value for this TGuiTextbox object.
	End Rem
	Method Settext(Value:String)
		text = Value
		lineheight = TextHeight(value)
		recalcText()
	End Method
	
	Method recalcText()
		If Self.width <= TextWidth(Chr(text[0])) Return 'no solution possible
		textlines.Clear()
		Local value:String = text
		
		Local counter:Int = 0
		
		While value <> "" And (lineheight * (counter + 1)) < Self.height
			Local line:String = ""
			Local p:Int = 0
			Local lastp:Int = 0

			While TextWidth(line) < Self.width
				lastp = p
				'get next " " or nextline char
				While p < value.Length And value[p] <> Asc(" ")
					If value[p] = 10 'newline
						Exit
					EndIf
					p:+1
				Wend
				
				If p >= value.Length Exit
				If value[p] = 10
					p:+1 'so ~n sign isn't counted twice
					Exit
				EndIf
				
				line = Left(value, p)
				
				If value[p] = Asc(" ") And p + 1 < value.length p:+1
			Wend
			
			line = Left(value, p)
			If TextWidth(line) > Self.width p = lastp
			textlines.addlast(Left(value, p))
			If p = 0 p = 1
			value = Mid(value, p + 1)
			counter:+1
		WEnd
	End Method
	
	Rem
		bbdoc:Draws this object and all of its children
	End Rem
	method draw()
		If preDraw() Return
		SetBlend ALPHABLEND
		If drawrectbox
			setIntColor(rectboxcolor)
			DrawRect X, Y, width, height
		EndIf
		
		Local i:Int = 0
		For Local l:String = EachIn textlines
			Local tx:Float = X + (width - TextWidth(l)) * textGravityHorizontal
			Local ty:Float = Y
		
			If textshadow
				setIntColor(textshadowcolor)
				DrawText l, tx + 1, ty + 1 + i * lineheight
			End If
			setIntColor(textcolor)
			DrawText l, tx, ty + i * lineheight
			i:+1
		Next
		Super.draw()
	End Method

	
End Type
