'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TAreaDamageEffect Extends TTileMapDrawObject
	Global list:TList = New TList
	
	Function reset()
		list.Clear()
	End Function
	
	Function processAll(dt:Double, map:TTileMap)
		For Local e:TAreaDamageEffect = EachIn list
			e.process(dt, map)
		Next
	End Function
	
	Field link:TLink
	Field lifetime:Double
	Field lifetimemax:Double
	Field range:Float
	Field l:Float, r:Float
	Field color:Int
	Field impact:Int 'true if impactdamage was dealt
	
	Field damage:Double
	Field impactDamage:Double 'once dealt
	
	Field waiting:Byte'if true, effect will be paused
	
	Method New()
		link = list.AddLast(Self)
	End Method
	
	Method go()
		waiting = False
	End Method
	
	Method wait()
		waiting = True
	End Method
	
	Method process(dt:Double, map:TTileMap)
		If waiting Return
		If impact = False
			impact = True
			dealAreaDamage(impactDamage, map)
		End If
	
		lifetime:-dt
		If lifetime < 0
			remove()
			Return
		End If
		
		dealAreaDamage(damage * dt / 1000.0, map)
	End Method
	
	Method dealAreaDamage(dmg:Double, map:TTileMap)
		For Local il:Int = Self.l - range Until Self.l + range
			For Local ir:Int = Self.r - range Until Self.r + range
				If il < 0 Or il >= map.LSIZE Continue
				If ir < 0 Or ir >= map.RSIZE Continue
				Local range2:Float = range * range
				If (il - l) * (il - l) + (ir - r) * (ir - r) < range2
					If Not map.collision[il, ir].isEmpty()
						For Local e:TEnemy = EachIn map.collision[il, ir]
							Local dist2:Double = (e.l - l) * (e.l - l) + (e.r - r) * (e.r - r)
							If dist2 < range2
								e.receiveDamage(dmg, color)
								'e.receiveDamage(dmg * 1 / (1 + dist2), color)
							EndIf
						Next
					EndIf
				EndIf
			Next
		Next
	End Method
	
	Method draw(map:TTileMap)
		If waiting Return
		SetAlpha 0.2 * lifetime / lifetimemax
		applyIntColor(color)
		Local sizex:Float = range * TTileMap.TILE_W * 0.5 * (1 - lifetime / lifetimemax) ^ 0.2
		Local sizey:Float = range * TTileMap.TILE_H * 0.5 * (1 - lifetime / lifetimemax) ^ 0.2
		
		DrawOval x - sizex + map.offset_x, y - sizey + map.offset_y, 2 * sizex, 2 * sizey
		SetAlpha 1
		SetColor 255, 255, 255
	End Method
	
	Method remove()
		RemoveLink link
		link = Null
	End Method
End Type
