'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TBullet Extends TShootEffect
	Field image:TImage
	Field target:TEnemy
	Field damage:Double
	Field damageColor:Int
	Field x:Double, y:Double, speed:Double, acc:Double
	Field totaldist:Double, maxdist:Double = -1'total flight distance
	Field dir:Double
	Field impactEffect:TParticleEmitter
	Field areaEffectDamage:TAreaDamageEffect
	
	Method process(dt:Double, map:TTileMap)
		If target.isDead
			explode()
			remove()
			Return
		EndIf
	
		Local dx:Double = (target.centerX) - x
		Local dy:Double = (target.centerY) - y
		Local dist:Double = Sqr(dx * dx + dy * dy)
		'normieren
		dx:/dist
		dy:/dist
		
		speed:+acc * dt
		
		dx:*dt * speed
		dy:*dt * speed
		
		totaldist:+dt * speed
		
		dir = ATan2(dx, -dy)
		
		'check for arrival
		If (dist * dist < dx * dx + dy * dy) 'arrived
			x = target.centerX
			y = target.centerY
			If damage target.receiveDamage(damage, damageColor)
			explode()
		ElseIf maxdist > 0 And totaldist > maxdist
			explode()
		Else
			x:+dx
			y:+dy
		EndIf
	End Method
	
	Method explode()
		If areaEffectDamage And Not target.isDead
			areaEffectDamage.r = target.r
			areaEffectDamage.l = target.l
			areaEffectDamage.go()
		End If
		
		If impactEffect
			impactEffect.x = x
			impactEffect.y = y
			impactEffect.go()
		End If
		remove()
	End Method
	
	Method draw(offset_x:Double, offset_y:Double)
		SetRotation dir
		SetColor 255, 255, 255
		DrawImage image, x + offset_x, y + offset_y
	End Method
	
	Method remove()
		image = Null
		target = Null
		impactEffect = Null
		areaEffectDamage = Null
		Super.remove()
	End Method
	
End Type
