'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TEnemyTemplate
	Global map:TMap = CreateMap()
	
	Function reset()
		ClearMap(map)
	End Function
	
	Function Create:TEnemyTemplate(name:String, image:String, color:Int, credits:Int, hp:Double, speed:Double)
		Local et:TEnemyTemplate = New TEnemyTemplate
		et.name = name
		et.color = color
		et.credits = credits
		et.hp = hp
		et.speed = speed
		et.image = LoadImage(image)
		et.image.handle_y = et.image.height * 0.5 + et.image.height * 0.25'Kugel unten = Mittelpunkt
		et.image.handle_x = et.image.width * 0.5
		
		et.explosionImage = LoadImage("res/expl1.png")
		MidHandleImage(et.explosionImage)
		et.explosionColorGradient = TParticleEmitter.LoadColorGradient("res/explosionFarbverlaufGrey.png")
		For Local i:Int = 0 Until (et.explosionColorGradient.length / 4)
			et.explosionColorGradient[i, 1] = (et.color & $ff0000) Shr 16
			et.explosionColorGradient[i, 2] = (et.color & $ff00) Shr 8
			et.explosionColorGradient[i, 3] = et.color & $ff
		Next
		
		MapInsert(map, name, et)
		Return et
	End Function
	
	Function getByName:TEnemyTemplate(name:String)
		Assert MapValueForKey(map, name), "TEnemyTemplate.getByName() there is no entry with name = '" + name + "'"
		Return TEnemyTemplate(MapValueForKey(map, name))
	End Function

	Field name:String
	Field color:Int
	Field credits:Int
	Field hp:Double
	Field speed:Double
	Field image:TImage
	Field explosionImage:TImage
	Field explosionColorGradient:Int[,]
	
	Method spawn:TEnemy()
		Local e:TEnemy = New TEnemy
		e.image = image
		e.centerX = -image.handle_x + e.image.width / 2
		e.centerY = -image.handle_y + e.image.height / 2
		e.maxhp = hp
		e.hp = hp
		e.color = color
		e.credits = credits
		e.speed = speed
		e.enemyTemplate = Self
		Return e
	End Method
End Type
