'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TParticleExplosionEmitter Extends TParticleEmitter

	Function Create:TParticleExplosionEmitter(image:TImage, colorgradient:Int[,], x:Double, y:Double, maxSpeed:Double = 0.05, minLifeTime:Int = 500, maxLifeTime:Int = 2000, blendmode:Int = LIGHTBLEND)
		Local e:TParticleExplosionEmitter = New TParticleExplosionEmitter
		e.particleimage = image
		e.colorgradient = colorgradient
		e.x = x
		e.y = y
		e.maxSpeed = maxSpeed
		e.minLifeTime = minLifeTime
		e.maxLifeTime = maxLifeTime
		e.blendmode = blendmode
		Return e
	End Function
	
	
	Field spawned:Byte = False
	Field maxSpeed:Double
	Field minLifeTime:Int, maxLifeTime:Int
	
	Method processSpawn(dt:Double)
		
		If spawned = False
			'spawn particles
			For Local i:Int = 0 Until 10
				Local p:TParticle = getNewParticle()
				p.x = x
				p.y = y
				p.speedx = Rnd(-1, 1) * maxSpeed
				p.speedy = Rnd(-1, 1) * maxSpeed
				p.totallifetime = Rand(minLifeTime, maxLifeTime)
				p.lifetime = p.totallifetime
				addParticle(p)
			Next
			spawned = True
		ElseIf activeParticlesPointer < 0
			Self.remove()
		EndIf
	
	End Method
End Type
