'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TSpawner
	Function Create:TSpawner(enemy:String, path:String, amount:Int, startms:Double, msbetween:Double)
		Local s:TSpawner = New TSpawner
		s.enemy = TEnemyTemplate.getByName(enemy)
		s.path = TPath.getById(path)
		s.amount = amount
		s.startms = startms
		s.msbetween = msbetween
		Return s
	End Function
	
	Field enemy:TEnemyTemplate
	Field path:TPath
	Field amount:Int
	Field startms:Double
	Field msbetween:Double
	
	'changing values during process()
	Field passedTime:Double
	Field finished:Int
	Field amountSpawned:Int
	
	Method process:Int(dt:Double, tilemap:TTileMap)
		If finished Return finished
		
		passedTime:+dt
		If passedTime > startms And passedTime < startms + msbetween * amount
			Local shouldBeSpawned:Int = 1 + ((passedTime - startms) / msbetween) - amountSpawned
			If shouldBeSpawned + amountSpawned > amount shouldBeSpawned = amount - amountSpawned 'make sure maximal spawned number isn't higher that "amount", also if dt gets very high.
			
			Local offset:Double = (passedTime - startms) Mod msbetween
			
			amountSpawned:+shouldBeSpawned
			
			For Local i:Int = 0 Until shouldBeSpawned
				spawn(offset + i * msbetween, tilemap)
			Next
		ElseIf passedTime > startms + msbetween * amount
			finished = True
			Return finished
		EndIf
		Return False
	End Method
	
	Method spawn:TEnemy(tmp_dt:Double, tilemap:TTileMap)
		tilemap.totalSpawnedEnemies:+1
		Local e:TEnemy = enemy.spawn()
		e.way = path.path
		e.process(0, tilemap)
		tilemap.getXYforLRNoOffset(e.L, e.R, e.x, e.y) 'to make sure, x & y are already calculated for towers to fire
		e.centerX = e.x + tilemap.TILE_W * 0.5
		e.centerY = e.y + tilemap.TILE_H * 0.5
		
		e.process(tmp_dt, tilemap)
		Return e
	End Method
End Type
