'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TBlackHoleTower Extends TTower
	Field nextShot:Double
	Field range:Int = 4
	Field damage:Int = 500
	Field kills:Int
	Field color:Int = $ff000000
	
	Field loadTime:Float = 1000
	Field maxtargets:Int = 10
	
	
	Field killingSpree:Double
	Field bonusdamage:Double
	Field clock:Double
	
	Global image0:TImage
	Global image1:TImage
	Global image2:TImage
	Global laserimage:TImage
	

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		clock:+dt
		If killingSpree > 0
			killingSpree:-dt
		Else
			bonusdamage = 0
		EndIf
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			
			If Not targets.IsEmpty()
				Local targetCount:Int = Min(targets.Count(), maxtargets)
				Local counter:Int = 0
				For Local e:TEnemy = EachIn targets
					counter:+1
					If counter > maxtargets Exit
					If Not e.isDead
						e.receiveDamage((damage * 1 + bonusdamage) / targetCount, color)
						If e.isDead 'yes, i killed him
							killingSpree = 10000
							bonusdamage:+e.maxhp * 0.1
							kills:+1
						EndIf
						
						TLaserEffect.Create(x + 32, y - 16, e, laserimage, 500)
					EndIf
				Next
				nextShot:+loadTime
			Else
				nextShot = 50
			EndIf
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		DrawImage image0, x + map.offset_x, y + map.offset_y
		
		Local value:Double = clock * 0.0001
		
		Local changingColor:Int = getSaturatedColor(value)
		setIntColor(changingColor)
		DrawImage image1, x + map.offset_x, y + map.offset_y
		
		SetColor 255, 255, 255
		DrawImage image2, x + map.offset_x, y + map.offset_y
		
		If killingSpree > 0
			SetAlpha 0.5
			For Local i:Int = 0 Until Log(bonusdamage)
				SetScale 1 + i * 0.1, 1 + i * 0.1
				setIntColor(changingColor)
				DrawImage image1, x + map.offset_x - 0.1 * 32 * i, y + map.offset_y - 8 * i - 0.1 * 16 * i
				SetColor 255, 255, 255
				DrawImage image2, x + map.offset_x - 0.1 * 32 * i, y + map.offset_y - 8 * i - 0.1 * 16 * i
			Next
			SetScale 1, 1
			SetAlpha 1
		EndIf
	
		SetColor 255, 255, 255
	End Method
End Type
