'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:The most Basic Tower. Everything at this tower is basic ;)
End Rem
Type TFreezeTower Extends TTower
	Field nextShot:Double
	Field range:Int = 4
	Field damage:Int = 10
	Field color:Int = $ff0088ff
	
	Field loadTime:Float = 3000
	
	Global image:TImage
	Global laserimage:TImage
	

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			
			'Select the best target:
			Local bestEnemy:TEnemy, e:TEnemy
			
			For e:TEnemy = EachIn targets
				If Not e.isDead
					Local swap:Byte = False
					
					If bestEnemy = Null
						swap = True
					Else
						If e.effectAmount[TEnemy.EFFECT_FREEZE] / (1 + calcColorDistance(Self.color, e.color)) < bestEnemy.effectAmount[TEnemy.EFFECT_FREEZE] / (1 + calcColorDistance(Self.color, bestEnemy.color))
							swap = True
						End If
					EndIf
					If swap
						bestEnemy = e
					End If
				EndIf
			Next
			
			e = bestEnemy

			If e
				e.receiveDamage(damage, color)
				e.receiveEffect(6, 6000, color, TEnemy.EFFECT_FREEZE)
				nextShot:+loadTime
				
				TLaserEffect.Create(x + 32, y - 16, e, laserimage, 500)
			Else
				nextShot = 0
			EndIf
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
		SetColor 255, 255, 255
	End Method
End Type
