'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TTowerType
	Const TOWERCOUNT:Int = 11
	
	Const TOWER_BASIC:Int = 0
	Const TOWER_FREEZE:Int = 1
	
	Const TOWER_POISON:Int = 2
	Const TOWER_SPLASH:Int = 3
	
	Const TOWER_WEAKEN:Int = 4
	Const TOWER_FOCUS:Int = 5
	Const TOWER_MAGNETIC:Int = 6
	
	Const TOWER_CARRIER:Int = 7
	Const TOWER_CHAMELEON:Int = 8
	
	Const TOWER_VULCAN:Int = 9
	Const TOWER_BLACKHOLE:Int = 10

	
	
	
	
	Global info:TTowerType[TOWERCOUNT]
	Global _init:Byte = False
	
	Function init()
		If _init Return
		For Local id:Int = 0 Until TOWERCOUNT
			info[id] = New TTowerType
		Next
		
		info[TOWER_BASIC].name = "Basic Tower"
		info[TOWER_BASIC].description = "simple, white basic tower"
		info[TOWER_BASIC].damage = "single shot damage: 10"
		info[TOWER_BASIC].cost = 50
		
		info[TOWER_FREEZE].name = "Freeze Tower"
		info[TOWER_FREEZE].description = "freezes enemies so they move slower"
		info[TOWER_FREEZE].damage = "single shot damage: 5 and 6 sec +2 slow"
		info[TOWER_FREEZE].cost = 100
		
		info[TOWER_POISON].name = "Poison Tower"
		info[TOWER_POISON].description = "poison deals huge damage over time"
		info[TOWER_POISON].damage = "single shot damage: 2 + 20 * 4 sec"
		info[TOWER_POISON].cost = 150
		
		info[TOWER_SPLASH].name = "Splash Tower"
		info[TOWER_SPLASH].description = "Makes huge red splash damage"
		info[TOWER_SPLASH].damage = "area damage: 5 on Impact, 10 * 0.5 sec over time"
		info[TOWER_SPLASH].cost = 150
		
		info[TOWER_WEAKEN].name = "Weakening Tower"
		info[TOWER_WEAKEN].description = "weakens enemies so other towers make more damage"
		info[TOWER_WEAKEN].damage = "damage: 2 and 2 sec +4 weakening"
		info[TOWER_WEAKEN].cost = 300
		
		info[TOWER_FOCUS].name = "Focus Tower"
		info[TOWER_FOCUS].description = "high range, good against enemy with high hp"
		info[TOWER_FOCUS].damage = "increasing damage as longer this tower focusses one target"
		info[TOWER_FOCUS].cost = 300
		
		info[TOWER_MAGNETIC].name = "Magnetic Tower"
		info[TOWER_MAGNETIC].description = "Slows down everything within range"
		info[TOWER_MAGNETIC].damage = ""
		info[TOWER_MAGNETIC].cost = 300
		
		info[TOWER_CARRIER].name = "Carrier Tower"
		info[TOWER_CARRIER].description = "sends out 3 little multicolored fighters"
		info[TOWER_CARRIER].damage = "Fighters deal 20 dmg per shot"
		info[TOWER_CARRIER].cost = 1000
		
		info[TOWER_CHAMELEON].name = "Chameleon Tower"
		info[TOWER_CHAMELEON].description = "a tower who slowly changes his color to the most damage making one"
		info[TOWER_CHAMELEON].damage = ""
		info[TOWER_CHAMELEON].cost = 1000
		
		info[TOWER_VULCAN].name = "Vulcan Tower"
		info[TOWER_VULCAN].description = "a tower who spits pure damage"
		info[TOWER_VULCAN].damage = "pure unfocussed damage"
		info[TOWER_VULCAN].cost = 2500
		
		info[TOWER_BLACKHOLE].name = "Blackhole Tower"
		info[TOWER_BLACKHOLE].description = "A strong, dark tower"
		info[TOWER_BLACKHOLE].damage = "200 Damage + Bonusdamage divided between max 10 enemies"
		info[TOWER_BLACKHOLE].cost = 3500


		
		_init = True
	End Function
	
	Function getInfo:TTowerType(id:Int)
		Return info[id]
	End Function
	
	Function CreateTower:TTower(id:Int)
		Local tower:TTower
		Select id
			Case TOWER_BASIC tower = New TBasicTower
			Case TOWER_FREEZE tower = New TFreezeTower
			Case TOWER_SPLASH tower = New TSplashTower
			Case TOWER_CARRIER tower = New TCarrierTower
			Case TOWER_POISON tower = New TPoisonTower
			Case TOWER_WEAKEN tower = New TWeakenTower
			Case TOWER_FOCUS tower = New TFocusTower
			Case TOWER_MAGNETIC tower = New TMagneticTower
			Case TOWER_VULCAN tower = New TVulcanTower
			Case TOWER_BLACKHOLE tower = New TBlackHoleTower
			Case TOWER_CHAMELEON tower = New TChameleonTower
		End Select
		
		Local towertype:TTowerType = getInfo(id)
		tower.cost = towertype.cost
		Return tower
	End Function
	

	Field name:String
	Field description:String
	Field damage:String
	Field cost:Int
	

End Type
