'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TVulcanTower Extends TTower
	Field nextShot:Double
	Field range:Int = 4
	Field color:Int = $ffff2200
	Field bulletsPerErruption:Int = 30
	Field bulletCounter:Int
	
	Field loadTime:Float = 12000
	
	
	Field state:Int
	
	Global image:TImage
	Global bulletimage:TImage
	Global explosionImage:TImage
	Global explosionColorGradient:Int[,]

	Method process(dt:Double, map:TTileMap)
		Select state
			Case 0 'waiting for beeing ready to fire
				nextShot:-dt
				If nextShot < 0 state = 1
			Case 1 'looking if a target is nearby
				Local targets:TList = getTargetsInRange(range, map)
				Local e:TEnemy = TEnemy(targets.First())
				If e
					state = 2
					bulletCounter = 0
				Else
					nextShot = 50
					state = 0
				EndIf
			Case 2'erruption
				If bulletCounter >= bulletsPerErruption
					state = 0
					nextShot:+loadTime
				Else
					If Rand(0, 2) = 0
						Local b:TGravityBomb = New TGravityBomb
						b.x = x + 32
						b.y = y - 16
						Local r:Double = Rnd(0, 0.5 * (TTileMap.TILE_W + TTileMap.TILE_H) * range)
						Local dir:Double = Rnd(0, 360)
						b.tx = x + Sin(dir) * r
						b.ty = y + Cos(dir) * r
						b.speed = 0.1
						b.acc = 0
						b.image = bulletimage
						
						
						Local dmg:TAreaDamageEffect = New TAreaDamageEffect
						dmg.wait()
						dmg.impactDamage = 40'damage
						dmg.damage = 100 'per second
						dmg.color = color
						dmg.range = 3
						dmg.lifetimemax = 1500
						dmg.lifetime = dmg.lifetimemax
						b.areaEffectDamage = dmg
							
							
							
						Local pe:TParticleEmitter = TParticleExplosionEmitter.Create(explosionImage, explosionColorGradient, 0, 0)
						pe.wait()
						b.impactEffect = pe
						bulletCounter:+1
					EndIf
				EndIf
		End Select
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
	End Method
End Type
