﻿
Include "Hilfsfunktionen.bmx"

Global zoomFaktor:Float = 0.5
Global deletedMem:Int = 0

Type bla
	Global src:Int[] = [GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA, GL_CONSTANT_COLOR]
	Global dst:Int[] = [GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA, GL_CONSTANT_COLOR]
	
	Global srci:Int = 0
	Global dsti:Int = 0
	
	Global timer:Int = MilliSecs() + 20000
	
	Global interval:Int = 2500
	
	Global stop:Int = 0
	
	Function updateBlend()
		Local force:Int = KeyHit(KEY_SPACE)
		If KeyHit(KEY_DOWN) Then Stop = Not stop
		If Not KeyDown(KEY_ENTER) Or force Then
			If Not stop And timer < MilliSecs() Or force Then
				srci:+1
				
				If srci >= Len(src) Then
					srci = 0
					dsti:+1
					
					If dsti >= Len(dst) Then
						dsti = 0
					End If
				End If
				
				timer = MilliSecs() + interval
			EndIf
		Else
			If force = 0 Then
			Print "DEST: " + dsti
			Print "SRC: " + srci
			EndIf
		End If
		If KeyHit(KEY_LEFT) Then interval:-100
		If KeyHit(KEY_RIGHT) Then interval:+100
		
		glBlendFunc(src[srci], dst[dsti])
	End Function
End Type

Global shadowLen:Float = 1.0
Global shadowCol:Float[] = [0.0, .0, .0, .45]
Global shadowAngle:Int = 240.0


Function SetShadowLinear(angleNew:Float, lenNew:Float)
	shadowAngle = angleNew
	shadowLen = lenNew
		
	For Local k:TKachel = EachIn TKachel.list
		k.calcShadow(shadowAngle, shadowLen)
	Next
	For Local f:TFrame = EachIn TFrame.list[FRAMESET_TOWER]
		f.calcShadow(shadowAngle, shadowLen)
	Next

End Function

Function Update_PK()
	If Not gameover Then
	
	If KeyHit(KEY_SPACE) Then
		If TGameControl.GameStarted = 0 Then TGameControl.StartGame()
	End If
	
	If KeyHit(KEY_M) Then
		If focusMarktplatz Then
		
			If tgame.FocusObject = tgame.Burg Then
				ClearFocus(1)
			End If
			
			focusMarktplatz = 0
		Else
			If tgame.FocusObject <> tgame.Burg Then
				SetFocus(tgame.burg)
			End If
			focusMarktplatz = 1
		EndIf

	End If
	
	If KeyHit(KEY_Q) Then
		'vorherigen tower aktivieren.
		If Not TTower.lastTower Then
			'es gab keinen tower.
			Local _l:Object = TTower.activeTower.Last()
			
			If _l Then
				TTower.lastTower = TTower(_l)
				SetFocus(_l)
			End If
		Else
			Local link:TLink = TLink(TTower.activeTower.FindLink(TTower.lastTower))
			
			If link And link.PrevLink() Then
				Local tower:Object = link.PrevLink().Value()
				TTower.lastTower = TTower(tower)
				SetFocus(tower)
			Else
				Local _l:Object = TTower.activeTower.Last()
				
				If _l Then
					TTower.lastTower = TTower(_l)
					SetFocus(_l)
				End If
			End If
		End If
	End If
	If KeyHit(KEY_E) Then
		'nächsten tower aktivieren.
		If Not TTower.lastTower Then
			'es gab keinen tower.
			Local _l:Object = TTower.activeTower.first()
			
			If _l Then
				TTower.lastTower = TTower(_l)
				SetFocus(_l)
			End If
		Else
			'es gab einen tower: Link suchen
			Local link:TLink = TLink(TTower.activeTower.FindLink(TTower.lastTower))
			
			
			If link And link.NextLink() Then
				'den nächsten link anfordern und den wert setzen.
				Local tower:Object = link.NextLink().Value()
				TTower.lastTower = TTower(tower)
				SetFocus(tower)
			Else
				'es gab kein link. ersten tower aktivieren!
				Local _l:Object = TTower.activeTower.first()
				
				If _l Then
					TTower.lastTower = TTower(_l)
					SetFocus(_l)
				End If
			End If
		End If
	End If

	
	Global scrollTimer:Int = 0
	REASON_BUILD_NOT_POSSIBLE = ""
'	For Local u:TUnit = EachIn TUnit.list
'		u.Update()
'	Next

	TTower.update()

	
	TUnitController.Update()

	If scrollTimer < tgame.mslocal
	Local _a:Float = KeyDown(KEY_A)
	Local _d:Float = KeyDown(KEY_D)
	Local _w:Float = KeyDown(KEY_W)
	Local _s:Float = KeyDown(KEY_S)
	
	If (_a + _d) Or (_w + _s) Then
	
		camX:+((-_a) + (_d) - _w + _s)' * TGameControl.gameSpeed
		camY:+((_a) - (_d) - _w + _s) '* TGameControl.gamespeed
		TLandschaft.map.update = 1 'erzwingt neufüllen der mapliste.
		scrollTimer = tgame.MSLocal + 50
	End If
	EndIf
	'/////////////////////////////////////////////////////////77////
	
	TGameControl.update()

	TWave.update()
	EndIf
End Function

Function DrawStep1_PK()
	glEnable(GL_TEXTURE_2D)
	glEnable(GL_DEPTH_TEST)
	glDepthFunc(GL_LEQUAL)
	glEnable (GL_BLEND) ; glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
	glAlphaFunc(GL_GREATER, 0.05)
	glEnable(GL_ALPHA_TEST)
	glEnable(GL_TEXTURE_2D)
	glBindTexture(GL_TEXTURE_2D, tex)

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST) ;

    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST) ;

	
	TLandschaft.map.Draw()
	

	glBindTexture(GL_TEXTURE_2D, TFrame.texture[FRAMESET_UNIT])
'	For Local u:TUnit = EachIn TUnit.list
'		u.draw(Tmouse.mouseTilePosX, Tmouse.mouseTilePosY)
'	Next
	glBindTexture(GL_TEXTURE_2D, tex)
	
	TUnitController.draw()
	
	TGameControl.Draw()
End Function

Function DrawStep2_PK()

	glBindTexture(GL_TEXTURE_2D, TLandschaft.map.minimap)

	Local breite:Int = 129
	Local hoehe:Int = 129
	
	Local x:Int = (-resx / 2) + 5
	Local y:Int = (resy / 2) - 129 - 6
	
	glDisable(GL_DEPTH_TEST)
	
	glBegin(GL_QUADS)

		glTexCoord2d(0.0, 0.0)
		
		glVertex3d(x, y, 1024)
		
		glTexCoord2d(1.0, 0.0)
		
		glVertex3d(x + breite, y, 1024)
	
		glTexCoord2d(1, 1)
		
		glVertex3d(x + breite, y + hoehe, 1024)
	
		glTexCoord2d(0.0, 1.0)
		
		glVertex3d(x, y + hoehe, 1024)
			
	glEnd()
	
	glDisable(GL_TEXTURE_2D)
	
	'units einzeichnen.
	Local px:Float = (128.0 / tlandschaft.map.sizeX) * 0.5
	Local py:Float = (128.0 / tlandschaft.map.sizeY) * 0.5
	
	Local _mmy:Int = y
	Local _mmx:Int = x + (breite / 2)
	Local ux:Float = 0
	Local uy:Float = 0
	
	glBlendFunc(GL_ONE, GL_ZERO)

	glPointSize(2.0)
	
	glBegin(GL_POINTS)
	glColor3f(1.0, 0.0, 0.0)
	For Local i:Int = 0 Until Len(TUnitController.oldPosArray)
		ux = -(px * TUnitController.oldPosArray[i][1]) + (px * TUnitController.oldPosArray[i][0]) + _mmx
		uy = (py * TUnitController.oldPosArray[i][1]) + (py * TUnitController.oldPosArray[i][0]) + _mmy
		
		glVertex2f(ux, uy)
	Next
	
	glColor3f(0.0, 1.0, 0.0)
	For Local i:Int = 0 Until Len(Tbuilding.PositionArray[0])
		
		ux = -(px * Tbuilding.PositionArray[0][i][1]) + (px * Tbuilding.PositionArray[0][i][0]) + _mmx
		uy = (py * Tbuilding.PositionArray[0][i][1]) + (py * Tbuilding.PositionArray[0][i][0]) + _mmy
		
		glVertex2d(ux, uy)
	Next
	
	glColor3f(0.8, .8, 0.0)
	For Local i:Int = 0 Until Len(Tbuilding.PositionArray[1])
		
		ux = -(px * Tbuilding.PositionArray[1][i][1]) + (px * Tbuilding.PositionArray[1][i][0]) + _mmx
		uy = (py * Tbuilding.PositionArray[1][i][1]) + (py * Tbuilding.PositionArray[1][i][0]) + _mmy
		
		glVertex2d(ux, uy)
	Next
	glColor3f(1.0, 1.0, 1.0)
	glEnd()

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glEnable(GL_TEXTURE_2D)
	glEnable(GL_DEPTH_TEST)
	glBindTexture(GL_TEXTURE_2D, tex)
End Function

Function DrawStep3_PK()
	
End Function
Function DrawStep4_PK()

End Function

Function PostFlip_PK()
	deletedMem = GCCollect()
End Function

Function zoomMatrix:Int(scale:Float)
	scale :/2.0
	glMatrixMode(GL_PROJECTION)  ' Projektionsmatrix auswählen.
	glLoadIdentity() 'Zurücksetzen der Matrix
		
	glOrtho(-resX * scale, resX * scale, resY * scale, -resY * scale, -1024, 1024)
	
		
	glMatrixMode(GL_MODELVIEW)
End Function
