﻿rem
	author: AnniXa, PhillipK
end rem	

SuperStrict

Include "includes\Tinifile.bmx"
Include "includes\TLandschaft.bmx"
Include "includes\Tunit.bmx"
Include "includes\Tgame.bmx"
Include "includes\sprite.bmx"
Include "includes\tweapon.bmx"
Include "includes\ttarged.bmx"
Include "includes\tprojectil.bmx"
Include "includes\twave.bmx"
Include "includes\tressource.bmx"
Include "includes\TFrame.bmx"
Include "includes\TTower.bmx"
Include "includes\TGameControl.bmx"
Include "includes\Wegfindung.bmx"
Include "includes\TUmkreissuche.bmx"
Include "includes\TAnimation.bmx"
Include "includes\TEffekt.bmx"
Include "includes\TMapLevel.bmx"




Include "BCC 57 AX.bmx"
Include "BCC 57 PK.bmx"

Const resX:Int = 1024, resY:Int = 768
Const resXHalf:Int = resx / 2, resYHalf:Int = resy/2
Const BLOCKDATA:String = "BlockData"
Const UNIT_DATA:String = "UnitData"
Const TOWER_DATA:String = "TowerData"
'Global ResX:Int = 1024
'Global ResY:Int = 768
StartOrthoGL(ResX, ResY)

Include "gui/gui.bmx"

'2 globale strings, werden im hautpmenü gesetzt.
Global mapIni:String = ""
Global mapPNG:String = ""

Global tex:Int = GLTexFromPixmap(LoadPixmap("blockdata\Blocks.png"))


Global spritetex:Int = GLTexFromPixmap(LoadPixmap("WeaponData\stuff.png"))
Global FORCE_CLOSE:Int = 0


Global translationX:Int = 0, translationY:Int = 0
Global camX:Int = 0, camY:Int = 0

Global timer:TTimer = CreateTimer(120)
Global lastRender:Int = 0

While FORCE_CLOSE <= 0

'------------------------------------------- 
' ins Hauptmenü springen:
Initgui()

If FORCE_CLOSE = 1 Then Exit

tgame.Burg = Null

FORCE_CLOSE = 0


runGame()


TTower.list = Null
THouse.list = Null
TFrame.list = Null
TUnitController.list = CreateList()
TTower.activeTower = CreateList()
THouse.activeHouse = CreateList()
TLandschaft.map = Null
TMapVorschau.list = CreateList()

Wend

End

'ALTE DATEI
Function runGame()


tGui.Init()
tgame.Init()


glewInit()
glEnable(GL_TEXTURE_2D)
glEnable(GL_DEPTH_TEST)
glDepthFunc(GL_LEQUAL)
glEnable (GL_BLEND) ; glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
glAlphaFunc(GL_GREATER, 0.05)
glEnable(GL_ALPHA_TEST)
glEnable(GL_TEXTURE_2D)
glBindTexture(GL_TEXTURE_2D, tex)

glDisable(GL_CULL_FACE)

TFrame.LoadFrames("TowerData\Data.ini", FRAMESET_TOWER)
TFrame.loadFrames("UnitData\Data.ini", FRAMESET_UNIT)
THouse.LoadData("TowerData\Tower.ini")
TTower.LoadData("TowerData\Tower.ini")
TUnit.LoadData("UnitData\Units.ini")

TLandschaft.map = TLandschaft.LoadMap(mapPNG)

TMapData.LoadMapdata(mapIni)

TLandschaft.map.SetBuilding(TMapData.BurgX, TMapData.BurgY, Tbuilding.GetByID(255))
TMapData.burg = TLandschaft.map.buildings[TMapData.BurgX, TMapData.burgy]
camX = TMapData.BurgX
camY = TMapData.burgy

Local uks:TUmkreissuche = Tumkreissuche.Create(TMapdata.BurgX, tmapdata.burgy, TLandschaft.map)
TLandschaft.map.wegpunkte = uks.Search()

Assert TLandschaft.map.wegpunkte, "Wegpunkte haben nicht gefunzt"



ResetGuiButtons() 'die func muss ausgeführt werden, wenn sich die abhänigkeiten geändert haben (neue tower baubar etc)

Function ReturnOne:Int()
	Return tgame.mslocal
End Function

tEffekt_hilfstext.Create("Drücke [SPACE] um das Spiel zu beginnen!", [255,255,255], 0,0,0,0,0,0,0)

While FORCE_CLOSE = 0

	If KeyHit(KEY_ESCAPE) Then quit = 1
	
	If KeyHit(KEY_F12) Then gameover:-1

	If KeyHit(KEY_NUMADD) Then Tressource.Cheat()

	'Print TimerTicks(timer)
	
	Select True
		Case 1 ' lastRender + (1000.0 / 65.0) < tgame.ms
			update()
			render()
			
			lastRender = tgame.ms
			TGameControl.gamespeed = 120.0 / tgame.ofps
			WaitTimer(timer)
		Default
			TGameControl.gamespeed = 120.0 / tgame.ofps
			TGameControl.drawTicks:+1'TGameControl.gamespeed
			update()
			WaitTimer(timer)
	'	Default
	'		update()
	'	Case 2
	'		update()
	'	Case 3
	'		update()
	End Select

	PostFlip_PK()
	PostFlip_AX()
	
Wend
End Function

Function render()
	
	Cls
	
	DrawStep1_PK() '->Landschaft zeichnen.
	DrawStep1_AX()
	

	
	DrawStep2_PK()
	DrawStep2_Ax()
	
	DrawStep3_PK()
	DrawStep3_ax() '->Gui zeichnen.
	
'	GLDrawText("Mem freed: " + deletedMem, 50, 70)
'	GLDrawText("Anzahl TUC: " + TUnitController.list.Count(), 50, 90)
'	GLDrawText("Anzahl Effekte: " + TEffekt.list.Count(), 50, 110)
'	
'	GLDrawText("Gamespeed: "+TGameControl.gamespeed, 50, 130)
'	GLDrawText("Waffenanzahl: " + TTower.wcount, 50, 150)
'	GLDrawText("Turmanzahl: " + TTower.activeTower.Count(), 50, 170)
'	
'	GLDrawText("MausPos: " + Tmouse.PosX + " " + Tmouse.posy, 50, 200)
'	GLDrawText("MausPos2: " + (resX - Tmouse.PosX) + " " + (resY - Tmouse.posy), 50, 220)
		
	DrawStep4_PK()
	DrawStep4_AX()
	

	Flip 0

	TGameControl.drawTicks:+1'TGameControl.gamespeed
End Function
Function update()
	Tmouse.UpdateMouseVars() 'hack phillipk: Bei meinen funktionen kam nurnoch selten bis garnicht ein LMB an!
							' deshalb: aufspalten und MouseDraw und MouseVars. MouseVars werden nun direkt zu anfang eingelesen.
							' -> fixed, mausupdate lief 2x^^
	Update_PK()
	Update_AX()
	
End Function


Function StartOrthoGL(Width:Int, Height:Int, depth:Int = 0, hertz:Int = 60)
	EndGraphics()
	SetGraphicsDriver(GLMax2DDriver())
	'GLGraphics(Width, Height, depth, hertz) 'OpenGL fenster initialisieren - danke blitzmax! :)
	Graphics(Width, Height, depth, hertz)'mod by annixa (für max2d kompatibilität)
	
	glMatrixMode(GL_PROJECTION)  ' Projektionsmatrix auswählen.
	glLoadIdentity() 'Zurücksetzen der Matrix
	
	glOrtho(-Width / 2, Width / 2, Height / 2, -Height / 2, -4096, 4096)

	glMatrixMode(GL_MODELVIEW)

End Function

Function Cls()
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
End Function

