﻿Rem
	Animationstype.
	Liefert immer ein aktuelles TFrame zum zeichnen.
	Update erfolgt unmittelbar vor dem zeichnen.
	
	author: PhillipK
End rem
Type TAnimation
	Field frame:TFrame 'aktueller frame.
	Field frameIndex:Int = 0 'aktueller frame aus dem framset.
	
	Field tuc:TUnitController 'unitcontroller der beeinflusst wird.
	
	Field nextUpdate:Int = 0 'nächstes update in game-ticks.
	
	Field CurrentAnim:Int = ANIMATION_STAND 'aktuelle animations-art die durchlaufen wird (gehen, stehen, angreifen, etc)
	
	Field frmst:Int[] 'pointer auf das aktuelle set.
	
	Field oldDir:Int = 0
	
	Field offset:Int = 0
	
	Function CreateWithWalk:TAnimation(tuc:TUnitController)
		Local ani:TAnimation = New TAnimation
		ani.tuc = tuc
		ani.nextUpdate = -1
		ani.doMove()
		Return ani
	End Function
	Function CreateWithStand:TAnimation(tuc:TUnitController)
		Local ani:TAnimation = New TAnimation
		ani.tuc = tuc
		ani.nextUpdate = -1
		ani.doStand()
		Return ani
	End Function
	Function CreateWithDie:TAnimation(tuc:TUnitController)
		Local ani:TAnimation = New TAnimation
		ani.tuc = tuc
		ani.nextUpdate = -1
		ani.doDie()
		Return ani
	End Function
	Method Update:Int()
		Local dir:Int = tuc.dir
		
		If nextUpdate = -1 Then 'instant-update! frameset wurde geändert.
			frameIndex = 0
			Local framestindex:Int = -1
			
			Select CurrentAnim
				Case ANIMATION_STAND
					framestindex = ANI_STAND_N + dir
				Case ANIMATION_MOVE
					framestindex = ANI_MOVE_N + dir
				Case ANIMATION_DIE
					framestindex = ANI_DIE
				Case ANIMATION_DEAD
					framestindex = ANI_DEAD
				'	Print "TOT!!!"
				Case ANIMATION_ATTACK
					framestindex = ANI_ATK_N + dir
			End Select
			
			If Len(tuc.unit.framesets) > framestindex And Len(tuc.unit.framesets[framestindex]) > 0 Then
				'es ist möglich.
				frmst = tuc.unit.framesets[framestindex]
				Local tmpfrm:TFrame = TFrame.GetUnitFrameByID(frmst[frameIndex])
				
				If tmpfrm Then
			
					frame = tmpfrm
					
					nextUpdate = TGameControl.drawTicks + 20 - (tuc.unit.speed * 1.5) 'alle 15 ticks ein wechsel
			
				End If
		
			End If
		ElseIf nextUpdate <= TGameControl.drawticks Then
		
			If frameIndex = Len(frmst) - 1 Then
				'animation ist feritg. dh: Einmal durchgelaufen.
				tuc.action.onAnimReady()
			EndIf
		
			'zeit ist um: nächsten frame!
			frameIndex = (frameIndex + 1) Mod Len(frmst)
		
			
			Local tmpFrm:TFrame = TFrame.GetUnitFrameByID(frmst[frameIndex])
			
			If tmpfrm Then
				frame = tmpfrm
				
				
				nextUpdate = TGameControl.drawTicks + 20 - (tuc.unit.speed * 1.5) 'alle 15 ticks ein wechsel.
			End If
		ElseIf dir <> oldDir Then
			oldDir = dir
			
			Local framestindex:Int = -1
			
			Select CurrentAnim
				Case ANIMATION_STAND
					framestindex = ANI_STAND_N + dir
				Case ANIMATION_MOVE
					framestindex = ANI_MOVE_N + dir
				Case ANIMATION_DIE
					framestindex = ANI_DIE
				Case ANIMATION_DEAD
					framestindex = ANI_DEAD
				'	Print "TOT!!!"
				Case ANIMATION_ATTACK
					framestindex = ANI_ATK_N + dir
			End Select
			
			frmst = tuc.unit.framesets[framestindex]
			
			If Len(frmst) > frameIndex Then
				Local tmpfrm:TFrame = TFrame.GetUnitFrameByID(frmst[frameIndex])
				
				If tmpfrm Then
					frame = tmpfrm
			
				End If
			EndIf
		EndIf
		
	End Method
	Method doAttack:Int()
		If CurrentAnim <> ANIMATION_ATTACK Then
			CurrentAnim = ANIMATION_ATTACK
			nextUpdate = -1
			Update()
			
		End If
	End Method
	Method doMove:Int()
		If CurrentAnim <> ANIMATION_MOVE Then
			CurrentAnim = ANIMATION_MOVE
			nextUpdate = -1
			Update()
			
		End If
	End Method
	Method doStand:Int()
		If CurrentAnim <> ANIMATION_STAND Then
		CurrentAnim = ANIMATION_STAND
		nextUpdate = -1
			Update()
		
		EndIf
	End Method
	Method doDie:Int()
		If CurrentAnim <> ANIMATION_DIE Then
			CurrentAnim = ANIMATION_DIE
			nextUpdate = -1
			Update()
		End If
	End Method
	Method doDead:Int()
		If CurrentAnim <> ANIMATION_DEAD Then
			CurrentAnim = ANIMATION_DEAD
			nextUpdate = -1
			Update()
		End If
	End Method
End Type
