﻿Const RES_POP:Int = 0
Const RES_GOLD:Int = 1
Const RES_STONE:Int = 2
Const RES_WOOD:Int = 3
Const RES_METAL:Int = 4

Type Tressource
	Field id:Int
	
	Field Name:String
	Field _Max:Int
	Field Actual:Int
	Field Desc:String
	
	Field stopped:Int = 1
	
	Global Producer:TList = CreateList()
	
	Global zahltagAktiv:Int = 1
	Global zahltagKosten:Int = 0
	Global zahltagTimer:Int = 0
	
	Field Storage:TList
	Field IconGFX:Int[4]
	
	Function Cheat()
		tgame.Ressources[RES_GOLD].Plus(9999)
		tgame.Ressources[RES_STONE].Plus(9999)
		tgame.Ressources[RES_WOOD].Plus(9999)
		tgame.Ressources[RES_METAL].Plus(9999)
	End Function
	
	Function CheckBuild:Int(building:TBuilding)
	
		Local str:String = ""
	'	If TTower(building) Then str = "TOWE" + TTower(building)
		If THouse(building) Then str = "HOUS" + THouse(building).id
		
		Local _tmp:TBuildedHelper = TBuildedHelper(TMapdata.buildedList.ValueForKey(str))
		Local cnt:Float = 1.0
		
		If TTower(building) Then
			
		Else
		If _tmp Then
			cnt = (_tmp.builded + 1.0) * 1.1
		Else
			cnt = 1.0
		End If
	
		End If
		If tgame.Ressources[RES_POP].Check2(building.cost_population) And ..
		   tgame.Ressources[RES_GOLD].Check(building.cost_gold * cnt) And ..
		   tgame.Ressources[RES_STONE].Check(building.cost_stone * cnt) And ..
		   tgame.Ressources[RES_WOOD].Check(building.cost_wood * cnt) And ..
		   tgame.Ressources[RES_METAL].Check(building.cost_metal * cnt) Then
		   
				Return 1
		EndIf
		Return 0
	End Function
	
	Function CheckWeapBuild:Int(id:Int)
		Print "checks"
		If tgame.Ressources[RES_POP].Check2(tweapon.cost[id, RES_POP]) And ..
		   tgame.Ressources[RES_GOLD].Check(tweapon.cost[id, RES_GOLD]) And ..
		   tgame.Ressources[RES_STONE].Check(tweapon.cost[id, RES_STONE]) And ..
		   tgame.Ressources[RES_WOOD].Check(tweapon.cost[id, RES_WOOD]) And ..
		   tgame.Ressources[RES_METAL].Check(tweapon.cost[id, RES_METAL]) Then
		   
				Return 1
		EndIf
		Return 0
	End Function
	
	Function DoWeapBuild:Int(id:Int)
		If tgame.Ressources[RES_POP].Check2(tweapon.cost[id, RES_POP]) And ..
		   tgame.Ressources[RES_GOLD].Check(tweapon.cost[id, RES_GOLD]) And ..
		   tgame.Ressources[RES_STONE].Check(tweapon.cost[id, RES_STONE]) And ..
		   tgame.Ressources[RES_WOOD].Check(tweapon.cost[id, RES_WOOD]) And ..
		   tgame.Ressources[RES_METAL].Check(tweapon.cost[id, RES_METAL]) Then
		   
				tgame.Ressources[RES_POP].Plus(tweapon.cost[id, RES_POP])
				tgame.Ressources[RES_GOLD].Minus(tweapon.cost[id, RES_GOLD])
				tgame.Ressources[RES_STONE].Minus(tweapon.cost[id, RES_STONE])
				tgame.Ressources[RES_WOOD].Minus(tweapon.cost[id, RES_WOOD])
				tgame.Ressources[RES_METAL].Minus(tweapon.cost[id, RES_METAL])
				Return 1
		EndIf
		Return 0
	End Function
	
	Function DoBuild:Int(building:TBuilding)

	
		Local str:String = ""
	'	If TTower(building) Then str = "TOWE" + TTower(building)
		If THouse(building) Then str = "HOUS" + THouse(building).id
		
		Local _tmp:TBuildedHelper = TBuildedHelper(TMapdata.buildedList.ValueForKey(str))
		Local cnt:Float = 1.0
		
		If TTower(building) Then
		
		Else
		
		If _tmp Then
			cnt = (_tmp.builded) * 1.035
		Else
			cnt = 1.0
		End If
		
		EndIf
		
		If tgame.Ressources[RES_POP].Check2(building.cost_population) And ..
		   tgame.Ressources[RES_GOLD].Check(building.cost_gold * cnt) And ..
		   tgame.Ressources[RES_STONE].Check(building.cost_stone * cnt) And ..
		   tgame.Ressources[RES_WOOD].Check(building.cost_wood * cnt) And ..
		   tgame.Ressources[RES_METAL].Check(building.cost_metal * cnt) Then
		   
				tgame.Ressources[RES_POP].Plus(building.cost_population)
				tgame.Ressources[RES_GOLD].Minus(building.cost_gold * cnt)
				tgame.Ressources[RES_STONE].Minus(building.cost_stone * cnt)
				tgame.Ressources[RES_WOOD].Minus(building.cost_wood * cnt)
				tgame.Ressources[RES_METAL].Minus(building.cost_metal * cnt)
		   
				Local str:String = ""
		'		If TTower(building) Then str = "TOWE" + TTower(building)
				If THouse(building) Then
					str = "HOUS" + THouse(building).id
					If THouse(building).id = (138 - 128) Then tgame.Ressources[RES_POP]._Max:+2
				
				Local _tmp:TBuildedHelper = TBuildedHelper(TMapdata.buildedList.ValueForKey(str))
				
				If _tmp Then
					_tmp.builded:+1
				Else
					Local _tmp:TBuildedHelper = New TBuildedHelper
					_tmp.builded:+1
					TMapData.buildedList.Insert(str, _tmp)
				End If
				EndIf
				Return 1
		EndIf
		Return 0
	End Function
	
	Function AddProducer:Int(house:THouse)
		Producer.AddLast(house)
	End Function
	
	Function RemoveProducer:Int(house:Tbuilding)
		Producer.Remove(house)
	End Function
	
	Function Update:Int()
		For Local house:THouse = EachIn Producer
			If house.currUpdateRate < tgame.mslocal Then
				If house.GivesGold() And tgame.Ressources[RES_GOLD].isActive() And tgame.Ressources[RES_GOLD].EnoughSpace(house.prod_g) Then
					addresFX(RES_GOLD, tgame.Ressources[RES_GOLD].Plus(house.prod_g), house.posx, house.posy, [128, 255, 128])
				EndIf
				If house.GivesWood() And tgame.Ressources[RES_WOOD].isActive() And Tressource.isPayable() And tgame.ressources[RES_WOOD].EnoughSpace(house.prod_w) Then
					addresFX(RES_WOOD, tgame.Ressources[RES_WOOD].Plus(house.prod_w), house.posx, house.posy, [128, 255, 128])
					
					zahltagKosten:+zahltagAktiv
				EndIf
				If house.GivesStone() And tgame.Ressources[RES_STONE].isActive() And Tressource.isPayable() And tgame.Ressources[RES_STONE].EnoughSpace(house.prod_s) Then
					addresFX(RES_STONE, tgame.Ressources[RES_STONE].Plus(house.prod_s), house.posx, house.posy, [128, 255, 128])
					
					zahltagKosten:+zahltagAktiv
				EndIf
				If house.GivesMetal() And tgame.Ressources[RES_METAL].isActive() And Tressource.isPayable() And tgame.Ressources[RES_METAL].EnoughSpace(house.prod_m) Then
					addresFX(RES_METAL, tgame.Ressources[RES_METAL].Plus(house.prod_m), house.posx, house.posy, [128, 255, 128])
					
					zahltagKosten:+zahltagAktiv
				EndIf
		'		If house.GivesPeople() Then addresFX(RES_POP, tgame.Ressources[RES_POP].minus(house.prod_p), house.posx, house.posy, [255, 128, 128])
				
				house.currUpdateRate = tgame.mslocal + (house.updateRate)
			EndIf
		Next
		
		If zahltagTimer < tgame.MSLocal Then
			If tgame.Ressources[RES_GOLD].Check(zahltagKosten) Then
				tgame.Ressources[RES_GOLD].Minus(zahltagKosten)
				zahltagKosten = 0
			Else
				zahltagKosten:-tgame.Ressources[RES_GOLD].Actual
				tgame.Ressources[RES_GOLD].Actual = 0
			EndIf
			
			zahltagTimer = tgame.MSLocal + 60000
		End If
		
	End Function
	
	Method isActive:Int()
		Return Not stopped
	End Method
	
	Function isPayable:Int()
		If Not zahltagAktiv Then Return 1
		
		Return tgame.Ressources[RES_GOLD].Check(Tressource.zahltagKosten + 1)
	End Function

	
	Function Create:tressource(Name:String, iconGFX:Int[], startamound:Int, maxamound:Int = 100, id:Int)
		Local newRessource:tressource = New Tressource
		newRessource.iconGFX = iconGFX
		newRessource.Name = Name
		newRessource.Actual = startamound
		newRessource._Max = maxamound
		newRessource.id = id
		Return newRessource
	End Function
	
	Function DrawInfo()
		For Local ActRessource:Int = 0 Until Len(tgame.Ressources)
			DrawSubImageRect(tGui.gfx, resX - (ActRessource * 100) - 100, 2, tgame.Ressources[ActRessource].IconGFX[2], tgame.Ressources[ActRessource].IconGFX[3], tgame.Ressources[ActRessource].IconGFX[0], tgame.Ressources[ActRessource].IconGFX[1], tgame.Ressources[ActRessource].IconGFX[2], tgame.Ressources[ActRessource].IconGFX[3])
			DrawText(tgame.Ressources[ActRessource].Actual + "/" + tgame.Ressources[ActRessource]._Max, resX - (ActRessource * 100) - 100 + tgame.Ressources[ActRessource].IconGFX[2], 6)
		Next
	End Function
	
	rem
		Eine kleine Hilfsmethode, die zb baukosten oder upgradekosten bequehm anzeigen lässt. 
		return: Returnt eine Neue X koordinate, die direkt neben dem zuletzt gezeichneten Icon liegt.
		
		Anmerkung: Man kann mithilfe einer X variable alle kosten zeichnen, diese methode entscheidet selbst, ob sie gezeichnet wird.
	end rem
	Method DrawIconAndValue:Int(x:Int, y:Int, value:Int, usePossibleColor:Int = 1, drawIfValueHighterThen:Int = 0)
		If value <= drawIfValueHighterThen Then Return x
		
		If usePossibleColor Then
			Select Self.id
				Case RES_POP
					
					If Self.Check2(value) = 0 Then
						SetColor(255,0,0)
					End If
				Default

					If Self.Check(value) = 0 Then
						SetColor(255, 0, 0)
					End If
			End Select
		End If
		
		DrawSubImageRect(tGui.gfx, x, y, IconGFX[2], IconGFX[3], IconGFX[0], IconGFX[1], IconGFX[2], IconGFX[3])
		
		DrawText(value, x + IconGFX[2], y)
		
		If usePossibleColor Then
			SetColor(255, 255, 255)
		EndIf
		Return x + IconGFX[2] + TextWidth(value) + 4
	End Method
	Method DrawIcon:Int(x:Int, y:Int)
		DrawSubImageRect(tGui.gfx, x, y, IconGFX[2], IconGFX[3], IconGFX[0], IconGFX[1], IconGFX[2], IconGFX[3])
	End Method
		
	Method Plus:Int(menge:Int)
		If menge = 0 Then Print "??? sollte 0 zu ressource: " + Self.Name + " adden??" ;Return 0
		If Self.Actual + menge > Self._Max Then
			Local dings:Int = Self._max - Self.actual'menge die geaddet werden konnte
			Self.Actual = Self._Max
			Print "Adde zu " + Self.Name + " eine menge von " + menge + " ACHTUNG LAGER VOLL!"
			Return dings
		Else
			Self.Actual:+menge
			Print "Adde zu " + Self.Name + " eine menge von " + menge
			Return menge
		End If

	end Method
	
	Method Minus:Int(Menge:Int)
		If Self.Actual >= Menge Then
			Self.Actual:-Menge
			Return 1
		EndIf
		Return 0
	End Method
	
	Method EnoughSpace:Int(Menge:Int)
		If Self.Actual + Menge <= Self._Max Then Return 1
		
		Return 0
	End Method
	
	Method Check:Int(MEnge:Int)
		If Self.Actual >= MEnge Then Return 1
	End Method
	
	Method Check2:Int(MEnge:Int)
		If (Self.Actual + menge) <= Self._Max Then Return 1
	End Method
	
	Function ResetAllStorages()'wenn neues lager gebaut/oder eines abgerisen wurde:
		For Local ActRessource:Int = 0 Until Len(tgame.Ressources)
			'todo: alle lagerstätten zählen und so
			'tgame.Ressources[ActRessource]._Max = 1000
		Next
	End Function
	
	Function GetByName:Tressource(name:String)
		For Local res:Tressource = EachIn tgame.Ressources
			If Lower(name) = Lower(res.name) Then Return res
		Next
		Return Null
	End Function
End Type