﻿Type TBreitensuche
	Field liste:TList = CreateList()
	Field visited:tbsNode[,]
	
	Field map:TLandschaft
	Field map2:Byte[,]
	
	Field eX:Int = 0
	Field ey:Int = 0
	
	Field sX:Int = 0
	Field sY:Int = 0
	
	Field DirX:Int[] = [- 1, 0, 1, 0]
	Field DirY:Int[] = [0, 1, 0, -1]
		
	
	Function Create:TBreitensuche(map:TLandschaft, sx:Int, sy:Int, ex:Int, ey:Int)
		If Not map Then Return Null
		
		If map.isBlocked(sX, sY) Or map.isBlocked(eX, ey) Then Return Null
		
		Local tbs:TBreitensuche = New TBreitensuche
		
		tbs.ex = ex
		tbs.ey = ey
		tbs.sx = sx
		tbs.sy = sy
		
		tbs.map = map
		tbs.map2 = map.__wegsucheMap
		
		tbs.visited = New TBSNode[map.sizeX, map.sizeY]
		
		Local node:TBSNode = TBsnode.Create(ex, ey, 0, Null)
		tbs.visited[ex, ey] = node
		
		tbs.liste.AddLast(node)
		
		Return tbs
	End Function
	
	Method Run:Int[][] ()
		Local ms:Int = MilliSecs()
		
		
		Local node:TBSNode, nNode:TBSNode
		Local x:Int, y:Int, i:Int

		
		While Not liste.IsEmpty()
			node = TBSNode(liste.removeFirst())
			
			If node.x = sX And node.y = sY Then
				'fertig!
				'node.costs enthält die etwa-anzahl an wegpunkten die gebrauch wurde.
				
				
				Local ret:Int[][]
				ret = ret[..node.costs * 3]
				
				Local odx:Int = 0, ody:Int = 0
				Local lastX:Int, lastY:Int
'				If node And node.prev Then
'				
'					odx = Sgn(node.prev.x - node.x)
'					ody = Sgn(node.prev.y - node.y)
'					
'					lastX = node.prev.x
'					lastY = node.prev.y
'					
'			'		ret[0][0] = lastX
'			'		ret[0][1] = lastY
'					
'					node = node.prev.prev
'					
'					
'					
'				EndIf
				
				Local i:Int = 0
				While node And i < Len(ret)
					'If Sgn(node.x - lastX) = odx And Sgn(node.y - lastY) = ody Then Continue
					
					ret[i] = [node.x, node.y]
					i:+1
					
					node = node.prev
				Wend
				node  = null
				
				ret = ret[..i]
				Self.liste.Clear()
				Self.map = Null
				Self.map2 = Null
				
				Self.visited = Null
				Local ms2:Int = MilliSecs() - ms
				Print "Dauer wegfindung über eine länge von " + Pythf(sX, sY, eX, ey) + "(pyth) feldern -> " + ms2 + "ms."
				
				Return ret
			End If
			
			For i = 0 Until 4
			
				x = DirX[i] + node.x
				y = DirY[i] + node.y
				
				'out of range check:
				If x < 0 Or y < 0 Or x >= map.sizeX Or y >= map.sizey Then Continue
				
				'Gucken ob hier ein gebäude steht oder obs ausserhalb der map ist:
				If map2[x, y] = 1 Then Continue
				
				'Gcken, ob wir hier schon waren:
				If visited[x, y] Then
					If visited[x, y].costs > node.costs + 1 Then
						'umpointern.
						visited[x, y].costs:+1
						visited[x, y] = node
					End If
					Continue
				EndIf
				nNode = TBSNode.Create(x, y, node.costs + 1, node)
				liste.AddLast(nNode)
				visited[x, y] = nNode
			Next
		Wend
	End Method
End Type
Type TBSNode
	Field x:Int, y:Int
	Field prev:TBSNode
	Field costs:Int
	
	Function Create:TBSNode(x:Int, y:Int, costs:Int, prev:TBSNode)
		Local bs:TBSnode = New TBSNode
		bs.x = x
		bs.y = y
		bs.prev = prev
		bs.costs = costs
		Return bs
	End Function
End Type