﻿Type tweapon_BasicMage Extends tweapon

	Method Fire()
		If Self.ProjectilID = 19 Then
			For Local ActInt:Int = 0 To 2
				Local newbullet:tProjectil = tprojectil.Projectil[Self.ProjectilID].Copy()
				Self.ShootsFired:+1
				newbullet.weapon = Self
				newbullet.ziel = Self.targed.ActualTarged
				newbullet.precision = Self.shuffle * 2
				newbullet.maxflew = Self.rangecaps[Self.id] + 1
				newbullet.onfire()
			Next
		Else
			Local newbullet:tProjectil = tprojectil.Projectil[Self.ProjectilID].Copy()
			Self.ShootsFired:+1
			newbullet.weapon = Self
			newbullet.ziel = Self.targed.ActualTarged
			newbullet.maxflew = Self.rangecaps[Self.id] + 1
			newbullet.precision = Self.shuffle
			newbullet.onfire()
		EndIf
	End Method

	Method Update:Int()
	'	Super.Update
		'prüfen ob der cooldown durch ist:
		If Self.CheckStandBy() Then
			If Self.CoolDownEnds < tgame.MSLocal Then
				'prüfen ob ein gültiges ziel vorhanden ist:
			
				If Self.targed.GetBestTarged(Self.tower, Self.ProjectilID, Self, tProjectil.Projectil[Self.ProjectilID].dotID) Then
				'	Print "---------------- BasicFIRE!!!!!! -"
					Self.Fire()
					Self.CoolDownEnds = tgame.MSlocal + Self.CoolDownTime
				'	Print "CD time: " + Self.CoolDownTime
				Else 'kein ziel gefunden, in standby schalten!
					StandBy()
				End If
			End If

		EndIf
	End Method

End Type


Type tprojectil_arkan Extends tProjectil

	Field oldposX:Float
	Field oldposY:Float
	
	Field VecX:Float
	Field VecY:Float
	
	Field rot:Int
	
	Field flew:Float
	
'	Field GND:Float = 0.03'turmhöhe!
'	Field BAL:Float = 0'ballistik fake
	
	Field alpha:Float = 1.0

	Method OnFire() 'anmerkung: hier ist das projektil bereits kopiert worden!
		'schadenspunkte der waffe addieren:
		Self.dmg:+Self.weapon.dmg
		
		Self.dmgScatter:+Self.weapon.dmgScatter 'auch den scatter range erhöhen! (mehr max krit, weniger halfmiss dmg)
		tProjectil.Projectiles.AddLast(Self)
		
	'	Local Ablenkung:Float = Float(Rand(-Self.precision, Self.precision)) * 0.1
		
		'schussvector erstellen
		'anmerkung phillipk: -0.75 um die urpsurngskachel ein wenig "hoch" zu verschieben. Da wo der turmkopf etwa sitzt.
		Local vX:Float = (Self.ziel.slotX + 0.5) - (Self.weapon.tower.posx + 0.75)  ' + Float(Rand(-Self.weapon.shuffle, Self.weapon.shuffle))
		Local vY:Float = (Self.ziel.sloty - 0.5) - (Self.weapon.tower.posy - 0.75)   '+ Float(Rand(-Self.weapon.shuffle, Self.weapon.shuffle))
		'Vektor: 
		
		'länge zum normalisieren:
		Local laenge:Float = Pythf(Self.ziel.slotx, Self.ziel.sloty, Self.weapon.tower.posx, Self.weapon.tower.posy)' * 7.0 * Self.speed  'speedup '+0.001 -> Divide by zero workarround
		
		'Normalisieren:
		Local Ablenkung:Float = Self.precision * 0.001
	
'		Print "ablenkung:" + Ablenkung
		
				
		Local vorzeichenX:Int = Rand(-1, 1)
		Local vorzeichenY:Int = Rand(-1, 1)
		
		Self.VecX = ((vX / laenge) * Float(Self.speed) * 0.001) + (Ablenkung * vorzeichenX * laenge)
 		Self.VecY = ((vY / laenge) * Float(Self.speed) * 0.001) + (Ablenkung * vorzeichenY * laenge)
		
'		Self.VecX = ((vX / laenge) * Float(Self.speed) * 0.001) + Ablenkung
'		Self.VecY = ((vY / laenge) * Float(Self.speed) * 0.001) + Ablenkung

		Self.Posx = Self.weapon.tower.Posx + 0.75
		Self.posy = Self.weapon.tower.posy - 0.75
		
		
		Self.rot = ATan2(VecY, VecX) + 90 + 45 'pfeilrotation
		GetSprite(Self.rot)
	End Method

	Method Copy:tProjectil()
		Local newbullet:tprojectil_arkan = New tprojectil_arkan
		newbullet.dmg = Self.dmg
		newbullet.speed = Self.speed
		newbullet.dmgScatter = Self.dmgScatter
		newbullet.precision = Self.precision
		newbullet.SpriteID = Self.SpriteID
		Return(newbullet)
	End Method

	Method Update:Int()
		If flew >= maxflew Then 'pfeil liegt auf dem boden, nichtmehr bewegen, nurnoch fadeout.
			Self.alpha:-0.01
			Draw(1)
		Else
			Self.oldposX = Posx
			Self.oldposy = posy
			Posx:+VecX
			posy:+VecY
			Self.flew:+tTarged.pdist(oldposX, oldposY, Posx, posy)
			
			If tgame.MSLocal & %111111 < tgame.particlerate Then tprojectil_FXarkan.Spawn(Posx, posy, 0)
			
		'	BAL:+0.00015
		'	BAL = BAL * 1.03
		'	Self.rot = ATan2(VecY, VecX) <<<<<<<<<<<<<- ?  
			'prüfen ob etwas getroffen wurde:
			Local getroffen:TUnitController = CheckSingleDamage()
			If getroffen Then'omg ich hab was getroffen!
				Local Schaden:Int = Self.dmg + Rand(-dmgScatter, dmgScatter)
				Schaden = getroffen.DoDamage(Schaden, Self.weapon.tower)

				tEffekt_numbers.Create(Schaden, [60, 255, 60], 0, 0, getroffen.slotX + 0.5, getroffen.sloty - 0.5, 0.1, 0, 500)
				
				If getroffen.unit.hp <= 0 Then 'tot
					getroffen.ACTION = New TUnitAction_die.Create(getroffen)
					Self.weapon.PushEXP(3, Schaden) 'lasthit = 3exp
				Else
					Self.weapon.PushEXP(1, Schaden) 'normalhit = 1exp
				EndIf
				Self.Destroy()
			End If
			Draw()
		EndIf
		
		If alpha <= 0 Then Self.Destroy()
				
	End Method
		
	Method Draw(dead:Int = 0)
	
		Local aposx:Int = ((Self.posx - camx) * (32)) - ((Self.posy - camy) * (32)) - 32
		Local aposy:Int = ((Self.posx - camx) * (16)) + ((Self.posy - camy) * (16)) - 16

'		Local bposx:Int = ((Self.oldposX - camx) * (32)) - ((Self.oldposy - camy) * (32)) - 32
'		Local bposy:Int = ((Self.oldposX - camx) * (16)) + ((Self.oldposy - camy) * (16)) - 16
		
		If aposx < - (resXHalf) - 50 Or aposy < - (resYHalf) - 50 Or aposx > (resXHalf) Or aposy > (resYHalf) Then
		Else
		glColor4f(1, 1, 1, Self.alpha)
		Self.sprite.Draw(aposx, aposy, Self.SpriteID)
'		Print Self.SpriteID

		EndIf
	End Method
	
End Type


Type tprojectil_arkanice Extends tProjectil

	Field oldposX:Float
	Field oldposY:Float
	
	Field VecX:Float
	Field VecY:Float
	
	Field rot:Int
	
	Field flew:Float
	
'	Field GND:Float = 0.03'turmhöhe!
'	Field BAL:Float = 0'ballistik fake
	
	Field alpha:Float = 1.0

	Method OnFire() 'anmerkung: hier ist das projektil bereits kopiert worden!
		'schadenspunkte der waffe addieren:
		Self.dmg:+Self.weapon.dmg
		
		Self.dmgScatter:+Self.weapon.dmgScatter 'auch den scatter range erhöhen! (mehr max krit, weniger halfmiss dmg)
		tProjectil.Projectiles.AddLast(Self)
		
	'	Local Ablenkung:Float = Float(Rand(-Self.precision, Self.precision)) * 0.1
		
		'schussvector erstellen
		'anmerkung phillipk: -0.75 um die urpsurngskachel ein wenig "hoch" zu verschieben. Da wo der turmkopf etwa sitzt.
		Local vX:Float = (Self.ziel.slotX + 0.5) - (Self.weapon.tower.posx + 0.75)  ' + Float(Rand(-Self.weapon.shuffle, Self.weapon.shuffle))
		Local vY:Float = (Self.ziel.sloty - 0.5) - (Self.weapon.tower.posy - 0.75)   '+ Float(Rand(-Self.weapon.shuffle, Self.weapon.shuffle))
		'Vektor: 
		
		'länge zum normalisieren:
		Local laenge:Float = Pythf(Self.ziel.slotx, Self.ziel.sloty, Self.weapon.tower.posx, Self.weapon.tower.posy)' * 7.0 * Self.speed  'speedup '+0.001 -> Divide by zero workarround
		
		'Normalisieren:
		Local Ablenkung:Float = Self.precision * 0.001
	
'		Print "ablenkung:" + Ablenkung
		
				
		Local vorzeichenX:Int = Rand(-1, 1)
		Local vorzeichenY:Int = Rand(-1, 1)
		
		Self.VecX = ((vX / laenge) * Float(Self.speed) * 0.001) + (Ablenkung * vorzeichenX * laenge)
 		Self.VecY = ((vY / laenge) * Float(Self.speed) * 0.001) + (Ablenkung * vorzeichenY * laenge)
		
'		Self.VecX = ((vX / laenge) * Float(Self.speed) * 0.001) + Ablenkung
'		Self.VecY = ((vY / laenge) * Float(Self.speed) * 0.001) + Ablenkung

		Self.Posx = Self.weapon.tower.Posx + 0.75
		Self.posy = Self.weapon.tower.posy - 0.75
		
		
		Self.rot = ATan2(VecY, VecX) + 90 + 45 'pfeilrotation
		GetSprite(Self.rot)
	End Method

	Method Copy:tProjectil()
		Local newbullet:tprojectil_arkanice = New tprojectil_arkanice
		newbullet.dmg = Self.dmg
		newbullet.speed = Self.speed
		newbullet.dmgScatter = Self.dmgScatter
		newbullet.precision = Self.precision
		newbullet.SpriteID = Self.SpriteID
		Return(newbullet)
	End Method

	Method Update:Int()
		If flew >= maxflew Then 'pfeil liegt auf dem boden, nichtmehr bewegen, nurnoch fadeout.
			Self.alpha:-0.01
			Draw(1)
		Else
			Self.oldposX = Posx
			Self.oldposy = posy
			Posx:+VecX
			posy:+VecY
			Self.flew:+tTarged.pdist(oldposX, oldposY, Posx, posy)
			
			If tgame.MSLocal & %1 = 1 Then tprojectil_FXice.Spawn(Posx, posy, 0)
			tprojectil_FXice.Spawn(Posx, posy, 0)
			tprojectil_FXice.Spawn(Posx, posy, 0)
			
		'	BAL:+0.00015
		'	BAL = BAL * 1.03
		'	Self.rot = ATan2(VecY, VecX) <<<<<<<<<<<<<- ?  
			'prüfen ob etwas getroffen wurde:
			Local getroffen:TUnitController = CheckSingleDamage()
			If getroffen Then'omg ich hab was getroffen!
				Local Schaden:Int = Self.dmg + Rand(-dmgScatter, dmgScatter)
				Schaden = getroffen.DoDamage(Schaden, Self.weapon.tower)

				tEffekt_numbers.Create(Schaden, [60, 255, 60], 0, 0, getroffen.slotX + 0.5, getroffen.sloty - 0.5, 0.1, 0, 500)
				
				If getroffen.unit.hp <= 0 Then 'tot
					getroffen.ACTION = New TUnitAction_die.Create(getroffen)
					getroffen.Freeze(Rand(5000 - 10000))
					Self.weapon.PushEXP(3, Schaden) 'lasthit = 3exp
				Else
					Self.weapon.PushEXP(1, Schaden) 'normalhit = 1exp
				EndIf
				Self.Destroy()
			End If
			Draw()
		EndIf
		
		If alpha <= 0 Then Self.Destroy()
				
	End Method
		
	Method Draw(dead:Int = 0)
	
		Local aposx:Int = ((Self.posx - camx) * (32)) - ((Self.posy - camy) * (32)) - 32
		Local aposy:Int = ((Self.posx - camx) * (16)) + ((Self.posy - camy) * (16)) - 16

		Local bposx:Int = ((Self.oldposX - camx) * (32)) - ((Self.oldposy - camy) * (32)) - 32
		Local bposy:Int = ((Self.oldposX - camx) * (16)) + ((Self.oldposy - camy) * (16)) - 16
		
		If aposx < - (resXHalf) - 50 Or aposy < - (resYHalf) - 50 Or aposx > (resXHalf) Or aposy > (resYHalf) Then
		Else
		glColor4f(1, 1, 1, Self.alpha)
		Self.sprite.Draw(aposx, aposy, Self.SpriteID - dead)
'		Print Self.SpriteID

		EndIf
	End Method
	
End Type

Type tprojectil_arkanblitz Extends tProjectil
	
	Field DmgDealt:Int
	Field LastDMG:Int
	
	Field alpha:Float = 2

	Method OnFire() 'anmerkung: hier ist das projektil bereits kopiert worden!
		'schadenspunkte der waffe addieren:
		Self.dmg:+Self.weapon.dmg
		Self.dmgScatter:+Self.weapon.dmgScatter 'auch den scatter range erhöhen! (mehr max krit, weniger halfmiss dmg)
		tProjectil.Projectiles.AddLast(Self)
		
			Local Schaden:Int = Self.dmg + Rand(-dmgScatter, dmgScatter)
			Schaden = ziel.DoDamage(Schaden, Self.weapon.tower)

			tEffekt_numbers.Create(Schaden, [60, 255, 60], 0, 0, ziel.slotX + 0.5, ziel.sloty - 0.5, 0.1, 0, 500)
			
			If ziel.unit.hp <= 0 Then 'tot
				ziel.ACTION = New TUnitAction_die.Create(ziel)
				Self.weapon.PushEXP(3, Schaden) 'lasthit = 3exp
			Else
				Self.weapon.PushEXP(1, Schaden) 'normalhit = 1exp
			EndIf
			
			tprojectil_FXflash.Spawn(ziel.slotX + 0.5 - 1, ziel.sloty - 0.5 - 1, 0)
			
			'Self.GetSprite(1)
		
	End Method

	Method Update:Int()
'		If alpha = 0 Then Self.Destroy()
'		Draw()
		Self.Destroy()
	End Method

	Method Draw()
'		'slotX - camX, sloty - camY
'		
'		alpha:-0.1
'	
'		Local uposx:Int = ((ziel.slotX + 0.5 - camx) * (32)) - ((ziel.sloty + 0.5 - camy) * (32))' - 16
'		Local uposy:Int = ((ziel.slotX - 0.5 - camx) * (16)) + ((ziel.sloty - 0.5 - camy) * (16))
'
'	'	Local tposx:Int = ((weapon.tower.Posx - camx) * (32)) - ((weapon.tower.posy - camy) * (32))
'	'	Local tposy:Int = ((weapon.tower.Posx - camx) * (16)) + ((weapon.tower.posy - camy) * (16)) - (weapon.tower.Frame.h * 0.7)
'				
'		glColor4f(1, 1, 1, Self.alpha)
'		
'		
'	'	Self.sprite.Draw(uposx, uposy, Self.SpriteID - (Rand(0, 2)))

	End Method
			
	Method Copy:tProjectil()
		Local newbullet:tprojectil_arkanblitz = New tprojectil_arkanblitz
		newbullet.dmg = Self.dmg
		newbullet.speed = Self.speed
		newbullet.dmgScatter = Self.dmgScatter
		newbullet.precision = Self.precision
		newbullet.SpriteID = Self.SpriteID
		Return(newbullet)
	End Method
End Type