﻿'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:A very basic XML-Like Reader (no schematics supported)
End Rem
Type TXMLReader

	'Returns a base TXMLNode containing the whole structure of the xml-file as childs.
	Function ReadXML:TXMLNode(stream:TStream)
		Assert stream <> Null, "TXMLReader.ReadXML() stream = null"
		Local state:Int
		
		Local STATE_BASE:Int = 0
		Local STATE_CLAMP:Int = 1
		Local STATE_INSIDE:Int = 2

		
		Local currentNode:TXMLNode = New TXMLNode
		state = STATE_BASE
		
	
		While Not stream.Eof()
			Local line:String = stream.ReadLine()
			Local pos:Int = 0
			
			While pos < line.Length
				Select state
					Case STATE_BASE
						If line[pos] = Asc("<") state = STATE_CLAMP
					Case STATE_CLAMP
						If line[pos] = Asc("/")
							While line[pos] <> Asc(">")
								pos:+1
							Wend
							currentNode = currentNode.parent
							state = STATE_BASE

						ElseIf line[pos] <> Asc(" ")
							Local newNode:TXMLNode = New TXMLNode
							currentNode.children.AddLast(newNode)
							newNode.parent = currentNode
							currentNode = newNode
							currentNode.name = readName(line, pos)
							state = STATE_INSIDE
							Continue'to jump over the +1
						EndIf
					Case STATE_INSIDE
						ignoreSpaces(line, pos)
						If pos < line.length
							If line[pos] = Asc("/")
								pos:-1
								state = STATE_CLAMP
							ElseIf line[pos] = Asc(">")
								state = STATE_BASE
							Else
								Local name:String = readName(line, pos)
								If line[pos] = Asc("=")
									Local variable:String = readValue(line, pos)
									MapInsert(currentNode.values, name, variable)
								EndIf
							EndIf
						EndIf
				End Select
			
			
				pos:+1
			WEnd
		Wend
		Return currentNode
	End Function
	
	
	Function ignoreSpaces(line:String, position:Int Var)
		While line[position] = Asc(" ")
			position:+1
			If line.Length >= position Return
		Wend
	End Function
	
	Function readName:String(line:String, position:Int Var)
		Local name:String = ""
		If line[position] = Asc(" ") Return Null
		Repeat
			Select line[position]
				Case Asc(" ") Return name
				Case Asc("/") Return name
				Case Asc(">") Return name
				Case Asc("=") Return name
				Default
					name = name + Chr(line[position])
			End Select
			position:+1
		Until position >= line.Length
		Return name
	End Function
	
	Function readValue:String(line:String, position:Int Var)
		Repeat
			position:+1
			If line.Length <= position Return Null
			If line[position] = 34 Exit 'Anführungszeichen
		Forever
			
		position:+1
	
		Local name:String = ""
		While position < line.Length
			Select line[position]
				Case 34 Return name
				Default
					name = name + Chr(line[position])
			End Select
			position:+1
		Wend
		Return name
	End Function

End Type
