'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc: An Instance of a Button, fully customizable via individual images.
	TODO:
	Add several images for the different states
	Smooth animation
End Rem
Type TGuiImageButton Extends TGuiAbstractButton
	Field image:TImage
	Field imageColor:Int = $ffffffff
	Field imageColorMouseOver:Int = $ffffffff
	Field imageLightMouseOver:Float = 0.5
	
	Field buttontext:String
	Field buttonTextColor:Int = $ffffffff
	Field buttonTextColorMouseOver:Int = $ffffffff
	Field buttonTextShadow:Byte = True
	
	Method calculatePosition()
		If Self.image
			Self.width = image.width
			Self.height = image.height
		EndIf
		Super.calculatePosition()
	End Method
	
	Method draw()
		If preDraw() Return
		SetBlend ALPHABLEND
		SetAlpha 1
		If state_mouseOver
			setIntColor(imageColorMouseOver)
		Else
			setIntColor(imageColor)
		EndIf
		DrawImage image, X, Y
		
		If state_mouseOver And imageLightMouseOver > 0
			SetBlend LIGHTBLEND
			SetAlpha imageLightMouseOver
			DrawImage image, X, Y
			SetAlpha 1
			SetBlend ALPHABLEND
		EndIf
			
		If buttontext
			Local tx:Float = X + (width - TextWidth(buttontext)) * 0.5
			Local ty:Float = Y + (height - TextHeight(buttontext)) * 0.5
			
			If buttonTextShadow
				SetColor 0, 0, 0
				SetAlpha 0.5
				SetBlend ALPHABLEND
				DrawText buttontext, tx + 1, ty + 1
			End If
			SetAlpha 1
			SetBlend ALPHABLEND
			If state_mouseOver
				setIntColor(buttonTextColorMouseOver)
			Else
				setIntColor(buttonTextColor)
			EndIf
			DrawText buttontext, tx, ty
		End If
		Super.draw()
	End Method
End Type
