'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type ViewLevelSelection Extends TView
	Field gui:TGUIObject
	Field fadeeffect:TViewFadeEffect
	Field logo:TImage
	
	Rem
		bbdoc:Fill this with content, no super-call needed
	End Rem
	Method onStart()
		'Dummy Textbox, just for easy movement and handling of all buttons.
		gui = New TGuiDummyBox
		
		fadeeffect = TViewFadeEffect.Create(TViewFadeEffect.FADEDIR_IN, 500, TViewFadeEffect.FADECALC_LINEAR, $ffffffff)
		logo = LoadImage("res/cdlogo.png")
		MidHandleImage(logo)
		Local levelbuttonimage:TImage = LoadImage("res/levelbutton.png")
		
		TLevelEntry.Init()
		TProgressManager.Load()
		
		Local buttonnumber:Int = TLevelEntry.list.Count()
		Local i:Int = 0
		For Local le:TLevelEntry = EachIn TLevelEntry.list
			Local levelbutton:TGuiImageButton = New TGuiImageButton
			levelbutton.name = "selectLevel"
			levelbutton.buttontext = le.name
			''levelbutton.buttonTextColor = $ff0088ff
			levelbutton.buttonTextColor = getSaturatedColor(i * 0.3)
			rem
			Select Rand(0, 5)
				Case 0 levelbutton.buttonTextColor = $ffff0000
				Case 1 levelbutton.buttonTextColor = $ff00ff00
				Case 2 levelbutton.buttonTextColor = $ff0000ff
				Case 3 levelbutton.buttonTextColor = $ffff8800
				Case 4 levelbutton.buttonTextColor = $ff0088ff
				Case 5 levelbutton.buttonTextColor = $ff8800ff
			End Select
			end rem
			levelbutton.buttonTextColorMouseOver = $ffffffff
			levelbutton.extra = le
			
			Local maxLines:Int = 6
			Local maxColumns:Int = Ceil(buttonnumber / maxLines)
			Local column:Int = Floor(i / maxLines)
			Local line:Int = i Mod maxLines
			levelbutton.SetPosition(200 * (column - maxColumns * 0.5), 45 * (line - maxLines * 0.5), 0.5, 0.55)
			
			
			levelbutton.SetHandle(0, 0, 0.5, 0)
			levelbutton.image = levelbuttonimage
			
			If le.pre'if there is a precondition
				Local ls:TLevelScore = TLevelScore.get(le.pre)
				If ls = Null
					levelbutton.setActive(False)
					
					
					levelbutton.buttonTextColor = $ff888888
					levelbutton.buttonTextColorMouseOver = levelbutton.buttonTextColor
					levelbutton.imageLightMouseOver = 0
				EndIf
			EndIf
			
			gui.add(levelbutton)
			i:+1
		Next
		

		
		Local button:TGuiImageButton = New TGuiImageButton
		button.name = "leave"
		button.image = LoadImage("res/leaveButton.png")
		button.SetPosition(-80, -30, 1, 1)
		button.midhandle()
		gui.add(button)
	End Method
	
	Method onEvent:Object(id:Int, event:TEvent, context:Object)
		Select event.id
			Case EVENT_KEYDOWN
				If event.data = KEY_ESCAPE TProgramManager.getInstance()._setCurrentView(New ViewCredits)
				Return Null
			Case TGuiObject.EVENT_BUTTONCLICKED
				Local button:TGuiAbstractbutton = TGuiAbstractbutton(event.source)
				
				Select button.name
					Case "selectLevel"
						Local levelEntry:TLevelEntry = TLevelEntry(button.extra)
						Local gm:ViewGameMap = New ViewGamemap
						gm.levelfile = levelEntry.file
						gm.levelid = levelEntry.id
						TProgramManager.getInstance()._setCurrentView(gm)
						gui.setActive(False)
					Case "leave"
						TProgramManager.getInstance()._setCurrentView(New ViewCredits)
				End Select

		End Select
	
		'pass the event over to the gui
		Return gui.onEvent(id, event, context)
	End Method
	
	Rem
		bbdoc:Fill this with content, no super-call needed. run method is called again and again until this view gets closed
	End Rem
	Method onProcess(dt:Double)

		If fadeeffect
			If fadeeffect.isFinished()
				fadeeffect = Null
			Else
				fadeeffect.process(dt)
			End If
		EndIf
		gui.process()
	End Method
	

	Method onDraw()
		setIntColor($ffffffff)
		DrawRect 0, 0, TProgramSettings.GFX_WIDTH, TProgramSettings.GFX_HEIGHT
		DrawImage logo, TProgramSettings.GFX_WIDTH * 0.5, 100
		gui.draw()
		If fadeeffect fadeeffect.draw()
	End Method
End Type
