'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Just for rendering laser shots
End Rem
Type TLaserEffect Extends TShootEffect
	Field image:TImage
	Field target:TEnemy
	
	Field x:Double, y:Double
	Field totalduration:Double
	
	
	'will be refreshed every process if target is still alive
	Field tx:Double, ty:Double
	Field duration:Double
	
	Function Create:TLaserEffect(x0:Double, y0:Double, target:TEnemy, image:TImage, duration:Double)
		Local le:TLaserEffect = New TLaserEffect
		le.x = x0
		le.y = y0
		le.target = target
		le.tx = target.centerX
		le.ty = target.centerY
		le.totalduration = duration
		le.duration = duration
		le.image = image		
		Return le
	End Function
	

	Method process(dt:Double, map:TTileMap)
		duration:-dt
		If duration < 0 remove()
		If target = Null Return
		If Not target.isDead
			tx = target.centerX
			ty = target.centerY
		EndIf
	End Method
	
	
	Method draw(offset_x:Double, offset_y:Double)
		SetColor 255, 255, 255
		SetAlpha duration / totalduration
		SetBlend LIGHTBLEND
		DrawImageLine(image, x + offset_x, y + offset_y, tx + offset_x, ty + offset_y)
		SetBlend ALPHABLEND
		SetAlpha 1
	End Method
	
	Method remove()
		image = Null
		target = Null
		Super.remove()
	End Method
End Type
