'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TProgressManager
	Global progressfile:String = "save/progress.xml"
	
	Function Load()
		Local stream:TStream = ReadFile(progressfile)
		If stream = Null Return
		Local basenode:TXMLNode = TXMLReader.ReadXML(stream)
		basenode = TXMLNode(basenode.children.first())
		Assert basenode.name = "progress", "TProgressManager.load() Failed: progress file exists, but somehow the content got screwed"
		For Local n:TXMLNode = EachIn basenode.children
			If n.name = "levelscore"
				TLevelScore.Create(n.getValue("id"), Int(n.getValue("score")), n.getValue("playername"))
			End If
		Next
		CloseFile stream
	End Function
	
	Function save()
		Local basenode:TXMLNode
		Local node:TXMLNode
		Local stream:TStream
		
		stream = WriteFile(progressfile)
		Assert stream, "TProgressManager.save() Failed: Cannot write file: " + progressfile
		basenode = New TXMLNode 'basenode
		basenode.name = "progress"
		
		Local ne:TNodeEnumerator = TLevelScore.levelscores.ObjectEnumerator()
		While ne.HasNext()
			Local n:TNode = TNode(ne.NextObject())
			node = New TXMLNode
			node.name = "levelscore"
			Local levelScore:TLevelScore = TLevelScore(n._value)
			node.setValue("id", levelScore.id)
			node.setValue("score", String(levelScore.score))
			node.setValue("playername", levelScore.playername)
			DebugLog "TProgressManager.save()" + node.getValue("id")
			basenode.children.AddLast(node)
		Wend

		TXMLWriter.WriteXML(basenode, stream)
		CloseFile stream
	End Function
End Type



