'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:A type that represents all shoot effects (mainly for drawing and processing purposes)
End Rem
Type TShootEffect Abstract
	Global list:TList = New TList
	
	Function reset()
		For Local se:TShootEffect = EachIn list
			se.remove()
		Next
		list.Clear()
	End Function
	
	Function processAll(dt:Double, map:TTileMap)
		For Local se:TShootEffect = EachIn list
			se.process(dt, map)
		Next
	End Function
	
	Function drawAll(offset_x:Double, offset_y:Double)
		For Local se:TShootEffect = EachIn list
			se.draw(offset_x, offset_y)
		Next
	End Function
	
	
	Field _link:TLink
	
	Method New()
		_link = list.AddLast(Self)
	End Method
	
	Method remove()
		RemoveLink(_link)
	End Method
	
	Method process(dt:Double, map:TTileMap) Abstract
	
	Method draw(offset_x:Double, offset_y:Double) Abstract
End Type
