'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:The most Basic Tower. Everything at this tower is basic ;)
End Rem
Type TBasicTower Extends TTower
	Field nextShot:Double
	Field range:Int = 5
	Field damage:Int = 10
	Field color:Int = $ffffffff
	
	Field loadTime:Float = 2000
	
	Field drawShot:Int
	Field lastShotTarget:Float[2]
	
	Global image:TImage
	Global bulletimage:TImage

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			
			'Select the best target:
			Local bestEnemy:TEnemy, e:TEnemy
			
			For e:TEnemy = EachIn targets
				If Not e.isDead
					Local swap:Byte = False
					
					If bestEnemy = Null
						swap = True
					Else
						If e.hp / calcColorDistance(Self.color, e.color) < bestEnemy.hp / calcColorDistance(Self.color, bestEnemy.color)
							swap = True
						End If
					EndIf
					If swap
						bestEnemy = e
					End If
				EndIf
			Next
			
			e = bestEnemy
			
			
			If e
				Local b:TBullet = New TBullet
				b.x = x + 32
				b.y = y - 16
				b.target = e
				b.speed = 0.5
				b.image = bulletimage
				b.damage = damage
				b.damageColor = color

				nextShot:+loadTime
				drawShot = 20
				lastShotTarget[0] = e.x + e.centerX + map.TILE_W * 0.5
				lastShotTarget[1] = e.y + e.centerY + map.TILE_H * 0.5
			Else
				nextShot = 0
			EndIf
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
	End Method
End Type
