'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TChameleonTower Extends TTower
	Field nextShot:Double
	Field range:Int = 6
	Field damage:Int = 100
	Field color:Int = $ffffffff
	
	Field loadTime:Float = 2000
	
	Field drawShot:Int
	Field lastShotTarget:Float[2]
	
	Global image:TImage
	Global imageTop:TImage
	Global laserimage:TImage
	

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			Local e:TEnemy = TEnemy(targets.First())
			If e
				'change color
				Local r0:Int = ($ff0000 & color) Shr 16
				Local g0:Int = ($ff00 & color) Shr 8
				Local b0:Int = $ff & color
				
				Local r1:Int = 255 - (($ff0000 & e.color) Shr 16)
				Local g1:Int = 255 - (($ff00 & e.color) Shr 8)
				Local b1:Int = 255 - ($ff & e.color)
				
				Local prog:Double = 0.2
				Local invProg:Double = 1 - prog
				
				r0 = invProg * r0 + prog * r1
				g0 = invProg * g0 + prog * g1
				b0 = invProg * b0 + prog * b1
				
				color = $ff000000 + r0 * $10000 + g0 * $100 + b0
			
				e.receiveDamage(damage, color)
				nextShot:+loadTime
				drawShot = 500
				lastShotTarget[0] = e.centerX
				lastShotTarget[1] = e.centerY
			Else
				nextShot = 0
			EndIf
		EndIf
		drawShot:-dt
	End Method
	

	
	Method draw(map:TTileMap)
		SetColor 255, 255, 255
		setalpha 1
		DrawImage image, x + map.offset_x, y + map.offset_y
		setIntColor(color)
		DrawImage imageTop, x + map.offset_x, y + map.offset_y
		
		If drawShot
			
			SetAlpha drawShot / 500.0
			Local sx:Double = x + map.offset_x + 32
			Local sy:Double = y + map.offset_y - 16
			Local tx:Double = lastShotTarget[0] + map.offset_x
			Local ty:Double = lastShotTarget[1] + map.offset_y
			setscale 1.1,1.1
			DrawImageLine(laserimage, sx, sy, tx, ty)
			SetScale 1, 1
			SetColor 255, 255, 255
			DrawImageLine(laserimage, sx, sy, tx, ty)
		EndIf
		SetColor 255, 255, 255
	End Method
End Type
