'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TFocusTower Extends TTower
	Field nextShot:Double
	Field range:Int = 8
	Field damage:Double = 6'damage per second
	Field color:Int = $ffffff00
	
	Field loadTime:Float = 1000
	
	Field target:TEnemy
	Field targetDuration:Double


	
	Global image:TImage
	Global laserimage:TImage
	

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		
		If nextShot < 0 And target = Null
			targetDuration = 0
			
			Local targets:TList = getTargetsInRange(range, map)
			
			'Select the best target:
			Local bestEnemy:TEnemy, e:TEnemy
			
			For e:TEnemy = EachIn targets
				If Not e.isDead
					Local swap:Byte = False
					
					If bestEnemy = Null
						swap = True
					Else
						If e.hp / (1 + calcColorDistance(Self.color, e.color)) < bestEnemy.hp / (1 + calcColorDistance(Self.color, bestEnemy.color))
							swap = True
						End If
					EndIf
					If swap
						bestEnemy = e
					End If
				EndIf
			Next
			
			target = bestEnemy
			
			
			If target
				nextShot = loadTime
			Else
				nextShot = 50'search every 50 ms for a new target
			EndIf
		ElseIf target
			If Not target.isDead
				If ((target.l - Self.l) ^ 2 + (target.r - Self.r) ^ 2) < Self.range * Self.range
					targetDuration:+dt
					Local dmg:Double = (damage * dt / 1000) * (1000 + targetDuration * 1.5) / 1000
					target.receiveDamage(dmg, color)
				Else
					target = Null
					nextShot = loadTime
				EndIf
			ElseIf target.isDead
				target = Null
				nextShot = loadTime
			EndIf
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
		
		If target
			SetColor 255, 255, 255
			Local sx:Double = x + map.offset_x + 32
			Local sy:Double = y + map.offset_y - 16
			Local tx:Double = target.centerX + map.offset_x
			Local ty:Double = target.centerY + map.offset_y
			DrawImageLine(laserimage, sx, sy, tx, ty)
		EndIf
		SetColor 255, 255, 255
	End Method
End Type
