'This BMX file was edited with BLIde ( http://www.blide.org )
Rem
	bbdoc:Undocumented type
End Rem
Type TPoisonTower Extends TTower
	Field nextShot:Double
	Field range:Int = 4
	Field damage:Int = 2
	Field color:Int = $ff11ff11
	
	Field loadTime:Float = 2000
	
	
	Global image:TImage, laserimage:TImage

	Method process(dt:Double, map:TTileMap)
		nextShot:-dt
		If nextShot < 0
			Local targets:TList = getTargetsInRange(range, map)
			
			'Select the best target:
			Local bestEnemy:TEnemy, e:TEnemy
			
			For e:TEnemy = EachIn targets
				If Not e.isDead
					Local swap:Byte = False
					
					If bestEnemy = Null
						swap = True
					Else
						If e.effectAmount[TEnemy.EFFECT_POISON] / (1 + calcColorDistance(Self.color, e.color)) < bestEnemy.effectAmount[TEnemy.EFFECT_POISON] / (1 + calcColorDistance(Self.color, bestEnemy.color))
							swap = True
						End If
					EndIf
					If swap
						bestEnemy = e
					End If
				EndIf
			Next
			
			e = bestEnemy
			
			If e
				e.receiveDamage(damage, color)
				e.receiveEffect(5, 8000, color, TEnemy.EFFECT_POISON)
				nextShot:+loadTime
				
				TPoisonEffect.Create(x + 32, y - 16, e, laserimage, 500)

			Else
				nextShot = 0
			EndIf
		EndIf
	End Method
	

	
	Method draw(map:TTileMap)
		setIntColor(color)
		DrawImage image, x + map.offset_x, y + map.offset_y
		SetColor 255, 255, 255
	End Method
End Type
