Global EWire1:TWireKind = New TWireKind
Private
EWire1.leekage = 0.1
EWire1.maxCapacity = 50
EWire1.draw = drawEWire1
EWire1.image = LoadImage("gfx/wire1.png")
EWire1.price = 10
EWire1.tooltip = "The cheapest wire"
Function drawEWire1(wire:TWire)
  Local l% = Float(wire.capacity)/EWire1.maxCapacity*128
  SetColor l+127, l+127, Float(wire.capacity)/EWire1.maxCapacity*255
  DrawOval wire.x*TILE_SIZE+TILE_SIZE/2-2, wire.y*TILE_SIZE+TILE_SIZE/2-2, 5, 5
  For Local conn:Object = EachIn wire.connections
    If TWire(conn) Then
      DrawLine wire.x*TILE_SIZE+TILE_SIZE/2, wire.y*TILE_SIZE+TILE_SIZE/2,..
               TWire(conn).x*TILE_SIZE+TILE_SIZE/2, TWire(conn).y*TILE_SIZE+TILE_SIZE/2
    Else
      DrawLine wire.x*TILE_SIZE+TILE_SIZE/2, wire.y*TILE_SIZE+TILE_SIZE/2,..
               TTower(conn).x*TILE_SIZE+TILE_SIZE/2, TTower(conn).y*TILE_SIZE+TILE_SIZE/2
    EndIf
  Next
End Function
