Rem
Replace ([Strg]+[H]) "highElectricity" by the name of your wire.
Adjust the values leekage, maxCapacity, production, price, source and drawhighElectricity as you want it.
Save the file AS wires/[n].bmx (don't overwrite wires/blanko.bmx).
Add 'Import "wires/[n].bmx"' to infra.bmx
At last, remove this note
End Rem
Global highElectricity:TWireKind = New TWireKind
highElectricity.leekage = 0.01
highElectricity.maxCapacity = 30
highElectricity.production = 0
highElectricity.price = 50
highElectricity.draw = drawhighElectricity
highElectricity.image = LoadImage("gfx/highElectricity.png")
Global HE_img:TImage = LoadImage("gfx/highElectricity_g.png")
highElectricity.tooltip = "A high voltage wire"
Function drawhighElectricity(wire:TWire)
  Local l% = Float(wire.capacity)/highElectricity.maxCapacity*128
  SetColor l+127, l+127, Float(wire.capacity)/highElectricity.maxCapacity*255


  For Local conn:Object = EachIn wire.connections
    If TWire(conn) Then
      DrawLine wire.x*TILE_SIZE+TILE_SIZE/2, wire.y*TILE_SIZE+TILE_SIZE/2,..
               TWire(conn).x*TILE_SIZE+TILE_SIZE/2, TWire(conn).y*TILE_SIZE+TILE_SIZE/2
    Else
      DrawLine wire.x*TILE_SIZE+TILE_SIZE/2, wire.y*TILE_SIZE+TILE_SIZE/2,..
               TTower(conn).x*TILE_SIZE+TILE_SIZE/2, TTower(conn).y*TILE_SIZE+TILE_SIZE/2
    EndIf
  Next

  SetColor 255, 255, 255
  DrawImage HE_img, wire.x*TILE_SIZE+TILE_SIZE/2, wire.y*TILE_SIZE+TILE_SIZE/2
End Function

