﻿Extern "C"
	Function CRand:Int() = "rand"
	Function SeedRnd(seed:Int) = "srand"
End Extern

Extern
	Function Memseti(Dest:Byte Ptr, Value:Int, Count:Int) = "memset"
EndExtern
Extern
	Function Memsetb(Dest:Byte ptr, Value:Byte, Count:int) = "memset"
End Extern

Rem
	bbdoc:Manhatten - distanz für Floats
End rem
Function MDistf:Float(x1:Float, y1:Float, x2:Float, y2:Float)
	Return Abs(x2 - x1) + Abs(y2 - y1)
End Function

Rem
	bbdoc:Manhatten - distanz für Integer
end rem
Function MDisti:Int(x1:Int, y1:Int, x2:Int, y2:Int)
	Return Abs(x2 - x1) + Abs(y2 - y1)
End Function

Function Pythi:Int(x1:Int, y1:Int, x2:Int, y2:Int)
	Return sqr((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1))
End Function

Function Pythf:Float(x1:Float, y1:Float, x2:Float, y2:Float)
	Return sqr((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1))
End Function

'Rem
'	bbdoc: Rand() hack - umschreiben auf C funktion 'rand' - parameter identisch.
'End Rem
'Function Rand:Int(min_value:Int, max_value:Int = 1)
'	'Return (CRand() & max_value) '+ min_Value
'	Local m:Float = max_value - min_value + 1
'	If m = 0 Then m = m+0.00001
'	Return (CRand() Mod (m) + min_value)
'End Function

Rem
	bbdoc: Hilfsfunktion, die die nachkommastellen eines Slots als X/Y verrechnet.
end rem
Function GetSlotoffset:Float(slotX:Float, slotY:Float, posx:Int Var, posy:Int Var)
	posx = ((((slotX - Int(slotX))) * (32)) - ((slotY - Int(slotY))) * (32)) - 32
	posy = ((((slotX - Int(slotX))) * (16)) + ((slotY - Int(slotY)) ) * (16)) - 16
End Function

Function GetXYBySlot(X:Float, Y:Float, posx:Int Var, posy:Int Var)
	posx = (x * (32)) - (y * (32)) - 32 ' x wert bestimmen - hier die gängige formel. -32 als X offset (zentrieren der kachel)
	posy = (x * (16)) + (y * (16)) - 16 ' y wert bestimmmen.
End Function