﻿Rem
	faulheits gui
	
	author: AnniXa
End Rem

Type tGui
		
	'hardcoded gui
	Global GFX:TImage
	Field PreRender() 'funcptr der vor dem gui render ausgefürt wird (für styling)
	Field Content:TList = CreateList()
	
	Global testvariableX:Int = 50'test variable für menu verschiebungen
	Global testvariableY:Int = 50'test variable für menu verschiebungen
	
	Field DecoData:Int[4]
		
	Field focusContent:tbutton
	
	Function Init()
		HideMouse()
	End Function
	
	Method Run() 'und draw
	
		If KeyHit (KEY_NUM2) Then testvariableY:-1
		If KeyHit (KEY_NUM8) Then testvariableY:+1
		If KeyHit (KEY_NUM6) Then testvariableX:-1
		If KeyHit (KEY_NUM4) Then testvariableX:+1
	
		'alle matrizen sichern
	
	'	glPushAttrib GL_ALL_ATTRIB_BITS

				
	'	SetBlend(ALPHABLEND)
	'	glEnable (GL_BLEND) ; glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
		
		Local glerror:Int = glGetError()
		
		If glerror Then Print "GLERROR!!! ---> " + glerror
			
		DrawText(" ", 0, 0) 'fps
				
	'	DrawImage(Self.GFX, 0, 0, 0)
		If Self.PreRender Then Self.PreRender()
		
		For Local ActButton:tButton = EachIn Self.Content
			ActButton.RunMe()
		Next
		
		DrawText("Tvars: X>" + testvariableX + "    Y>" + testvariableY, 150, 50)
		'textbereich

				
			
	End Method

	Function Create:tgui(image:TImage, prerender())
		Local newgui:tGui = New tGui
		newgui.GFX = image
		newgui.PreRender = PreRender
		Return newgui
	End Function
	
	Method AddButton:tbutton(posx:Int, posy:Int, Style:Int = 0, onClick(Value:Int), Value:Int, icon:Int, tt:String[])
		Local newbutton:tButton = tButton.Create(PosX:Int, PosY:Int, Style:Int, OnClick, Value:Int, icon:Int, tt:String, Null, Self)
		Self.Content.AddLast(newbutton)
		Return newbutton
	End Method
	
	Method ADdBuildButton:tButton(posx:Int, posy:Int, tower:tbuilding)
		Local newbutton:tButton = tbutton.Create(posx, posy, 0, SetMode_Build, tower.id, -1, [tower.Name], guiBlockImage, Self)
		newbutton.iconIntUv = tower.Frame.pngpos
		Self.Content.AddLast(newbutton)
	End Method

	
End Type

Type tButton
	Field PosX:Int'pos auf screen
	Field PosY:Int
	Field gfxX:Int'pos auf bild (uv)
	Field gfxY:Int
	Field SizeX:Int'size
	Field SizeY:Int
	
	Field Icon:Int'icon ID
	
	Field gui:tgui

	Global IconX:Int[] = [64, 40, 103, 40, 2, 38, 66, 40]'xa1,xa2,xb1,xb2 ....
	Global IconY:Int[] = [331, 40, 331, 40, 293, 18, 293, 40]
	
	Field iconIntUv:Int[] 'nur genutzt durch manche buttons
	
	Field icongfx:TImage
	
	Field tooltip:tTooltip = New ttooltip
	
	Field active:Int = 1
		
	Field OnClick(Value:Int) 'funktion die bei onclick ausgefürt wird
	Field Value:Int 'Value für diesen button (wird der onclick func übergeben)
	
	Function Create:tbutton(posx:Int, posy:Int, Styleb:Int = 0, onClick(Value:Int), Value:Int, icon:Int, tt:String[], icongfx:TImage = Null, gui:tgui)
		Local newButton:tButton = New tbutton
		If icongfx = Null Then icongfx = tGui.gfx
		newButton.icongfx = icongfx
		newButton.posx = posx
		newButton.posy = posy
		newButton.icon = icon
		newButton.gui = gui
		newButton.tooltip.TT_text = tt
		Local bumsda:Int
		For Local dingsda:Int = 0 Until tt.Length
			If TextWidth(tt[dingsda]) > bumsda Then bumsda = TextWidth(tt[dingsda])
		Next
		newButton.ToolTip.ttsize = bumsda
		If Styleb = 0 Then
				newButton.gfxX = 139
				newButton.gfxY = 461
				newButton.SizeX = 51
				newButton.SizeY = 51
		ElseIf Styleb = 1 Then
				newButton.gfxX = 145
				newButton.gfxY = 411
				newButton.SizeX = 48
				newButton.SizeY = 48
		ElseIf Styleb = 2 Then
				newButton.gfxX = 243
				newButton.gfxY = 494
				newButton.SizeX = 50
				newButton.SizeY = 25
		EndIf
		newButton.onClick = onClick
		newButton.Value = Value
		Return newbutton
	End Function
	
	Method RunMe() 'hässlichste runme() die ich jeh geschrieben habe^^
		If Self.active = 0 Then Return
		If Tmouse.Isover(Self.PosX, Self.PosY, Self.SizeX, Self.SizeY)
			If Tmouse.LMD Then
				If Self.OnClick Then 'wenn var vorhanden:
					Self.OnClick(Self.Value)
					If Self.Value <> - 1 Then gui.focusContent = Self
				EndIf
			EndIf
			If gui.focusContent = Self Then
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX + Self.SizeX, Self.gfxY, Self.SizeX, Self.SizeY)
				SetBlend(LIGHTBLEND)
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX + Self.SizeX, Self.gfxY, Self.SizeX, Self.SizeY)
				SetBlend(ALPHABLEND)
			Else
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX + Self.SizeX, Self.gfxY, Self.SizeX, Self.SizeY)
			End If
			
			If Icon < 0 Then
				DrawSubImageRect(icongfx, Self.PosX:Int + 6, Self.PosY:Int + 6, Self.SizeX, Self.SizeY, iconIntUv[0], iconIntUv[1], iconIntUv[2], iconIntUv[3])
				SetBlend(LIGHTBLEND)
				DrawSubImageRect(icongfx, Self.PosX:Int + 6, Self.PosY:Int + 6, Self.SizeX, Self.SizeY, iconIntUv[0], iconIntUv[1], iconIntUv[2], iconIntUv[3])
				SetBlend(ALPHABLEND)
			Else
				DrawSubImageRect(icongfx, Self.PosX:Int + 6, Self.PosY:Int + 6, IconX[Icon * 2 + 1], IconY[Icon * 2 + 1], IconX[Icon * 2], IconY[Icon * 2], IconX[Icon * 2 + 1], IconY[Icon * 2 + 1])
				SetBlend(LIGHTBLEND)
				DrawSubImageRect(icongfx, Self.PosX:Int + 6, Self.PosY:Int + 6, IconX[Icon * 2 + 1], IconY[Icon * 2 + 1], IconX[Icon * 2], IconY[Icon * 2], IconX[Icon * 2 + 1], IconY[Icon * 2 + 1])
				SetBlend(ALPHABLEND)
			EndIf
			
			
			
			Tmouse.TTbuffer = Self.tooltip
			Tmouse.hmode = 1
		Else
			If gui.focusContent = Self Then
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX, Self.gfxY, Self.SizeX, Self.SizeY)
				SetBlend(LIGHTBLEND)
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX + Self.SizeX, Self.gfxY, Self.SizeX, Self.SizeY)
				SetBlend(ALPHABLEND)
			Else
				DrawSubImageRect(tGui.GFX, Self.PosX:Int, Self.PosY:Int, Self.SizeX, Self.SizeY, Self.gfxX, Self.gfxY, Self.SizeX, Self.SizeY)
			End If
		
			If Icon < 0 Then
				DrawSubImageRect(icongfx, Self.posx:Int + 6, Self.posy:Int + 6, Self.SizeX, Self.SizeY, iconIntUv[0], iconIntUv[1], iconIntUv[2], iconIntUv[3])
				Else
				DrawSubImageRect(icongfx, Self.PosX:Int + 6, Self.PosY:Int + 6, IconX[Icon * 2 + 1], IconY[Icon * 2 + 1], IconX[Icon * 2], IconY[Icon * 2], IconX[Icon * 2 + 1], IconY[Icon * 2 + 1])
			End If
			

		End If
		
	End Method
	
End Type

Type basetooltip Abstract

	Method Draw() Abstract

End Type

Type tTooltip Extends basetooltip
	'tooltip holder
	Field TT_text:String[]
	Field ttsize:Int
	
	Function Create:tTooltip(tt:String[])
		Local newtt:tTooltip = New tTooltip
		Local bumsda:Int
		For Local dingsda:Int = 0 Until tt.Length
			If TextWidth(tt[dingsda]) > bumsda Then bumsda = TextWidth(tt[dingsda])
		Next
		newtt.ttsize = bumsda
		newtt.TT_text = tt
		Return newtt
	End Function
	
	Method Draw()
		'superschlechter tooltip^^
		Local DrawX:Int = Tmouse.PosX
		Local DrawY:Int = Tmouse.Posy
		If DrawX + ttsize > resX Then DrawX = resX - ttsize - 40
		If DrawY + (Len(TT_text) * 13) > resY Then DrawY = resY - (Len(TT_text) * 13)
		SetColor(0, 0, 0)
		SetAlpha(0.5)
		DrawRect(DrawX + 10, DrawY, ttsize + 8, TT_text.Length * 13 + 8)
		DrawRect(DrawX + 8, DrawY - 2, ttsize + 6, TT_text.Length * 13 + 6)
		SetColor(255, 255, 255)
		SetAlpha(1)
		DrawText(TT_text[0], DrawX + 10 + 2, DrawY + 0 * 13 + 2)
		SetColor(128, 128, 128)
		For Local Dings:Int = 1 Until TT_text.Length
			DrawText(TT_text[Dings], DrawX + 10 + 2, DrawY + Dings * 13 + 2)
		Next
		SetColor(255, 255, 255)
	End Method
End Type

Type twaveTT Extends basetooltip

	
	
	Field TT_text:String[]
	Field ttsize:Int
	Field icons:Int[]

	Function Create:twaveTT(iconID:Int[], tt:String[])
		Local newtt:twaveTT = New twaveTT
		Local bumsda:Int
		For Local dingsda:Int = 0 Until tt.Length
			If TextWidth(tt[dingsda]) > bumsda Then bumsda = TextWidth(tt[dingsda])
		Next
		newtt.ttsize = bumsda
		newtt.icons = iconID
		newtt.TT_text = tt
		Return newtt
	End Function

	Method Draw()
		'superschlechter tooltip^^
		Local DrawX:Int = Tmouse.PosX
		Local DrawY:Int = Tmouse.Posy
		If DrawX + ttsize > resX Then DrawX = resX - ttsize - 40
		If DrawY + (Len(TT_text) * 13) > resY Then DrawY = resY - (Len(TT_text) * 13)
		SetColor(0, 0, 0)
		SetAlpha(0.5)
		DrawRect(DrawX + 10, DrawY, ttsize + 8 + TWave.icons[icons[0]][2], TT_text.Length * 13 + 8)
		DrawRect(DrawX + 8, DrawY - 2, ttsize + 6 + TWave.icons[icons[0]][2], TT_text.Length * 13 + 6)
		SetColor(255, 255, 255)
		SetAlpha(1)
		DrawText(TT_text[0], DrawX + 10 + 2, DrawY + 0 * 13 + 2)
'		SetColor(128, 128, 128)
		For Local Dings:Int = 1 Until TT_text.Length
			DrawSubImageRect(guiImage, DrawX + 10, DrawY + Dings * 13, TWave.icons[icons[Dings - 1]][2], TWave.icons[icons[Dings - 1]][3], TWave.icons[icons[Dings - 1]][0], TWave.icons[icons[Dings - 1]][1], TWave.icons[icons[Dings - 1]][2], TWave.icons[icons[Dings - 1]][3])
			
			
			DrawText(TT_text[Dings], TWave.icons[icons[Dings - 1]][2] + DrawX + 10 + 2, DrawY + Dings * 13 + 2)
		Next
		SetColor(255, 255, 255)
	End Method	
		
End Type

Type Tmouse
	Global PosX:Int
	Global PosY:Int
	Global SpeedX:Int
	Global SpeedY:Int
	Global LMB:Int 'mousehit linke mausteaste
	Global LMB_doubleclick:Int 'mousehit wurde 2 x in kurzer folge realisiert.
	Global RMB:Int 'mousehit rechte maustaste
	Global RMB_doubleclick:Int 'mousehit wurde 2x in kurzer folge realisiert.
	
	Global _lmbMS:Int = 0
	Global _rmbMS:Int = 0
	
	Global LMD:Int 'mousedoen l
	Global RMD:Int
	Global State:Int 'mousestate
	Global TTbuffer:basetooltip
	Global hmode:Int
	
	Global cam_subx:Int
	Global cam_suby:Int
	
	Global mouseTilePosX:Float 'x koord relativ zur Campos 
	Global mouseTilePosY:Float 'y koord relativ zur Campos 
	Global mousePosXArr:Int 'x koord im maparray '@Phillipk
	Global mousePosYArr:Int 'y koord im maparray '@Phillipk
	
	Global building_under_mouse:TBuilding 'meist null!
	
	
	
	Function UpdateMouseVars()

	End Function
	
	Function UpdateMouseMENU()
	
		PosX = MouseX()
		PosY = MouseY()
		SpeedX = MouseXSpeed()
		SpeedY = MouseYSpeed()
		LMD = MouseDown(1) 'Phillipk: LMB / LMD von Mouse...(0) auf Mouse...(1) geändert, taste 0 ist nicht linksklick^^
		LMB = MouseHit(1)
		RMB = MouseHit(2)
		RMD = MouseDown(2)
		
		If LMB Then
			If MilliSecs() - _lmbMS < 500 Then
				LMB_doubleclick = 1
				
			Else
				_lmbMS = MilliSecs()
			End If
		Else
			LMB_doubleclick = 0
		End If
		
		
		hmode = 0
	End Function
	Function UpdateMouse()
	
		PosX = MouseX()
		PosY = MouseY()
		SpeedX = MouseXSpeed()
		SpeedY = MouseYSpeed()
		LMD = MouseDown(1) 'Phillipk: LMB / LMD von Mouse...(0) auf Mouse...(1) geändert, taste 0 ist nicht linksklick^^
		LMB = MouseHit(1)
		RMB = MouseHit(2)
		RMD = MouseDown(2)
		
		If LMB Then
			If _lmbMS > 0 And tgame.mslocal - _lmbMS < 500 Then
				LMB_doubleclick = 1
	
			Else
				_lmbMS = tgame.mslocal
			End If
		Else
			LMB_doubleclick = 0
		End If
		
		'Phillipk haxxort: Tile under maus abfragen.
		
		Rem
			berechnung der tilepos in der landschaft:
			posx = (x * (32)) - (y * (32)) + ox
			posy = (x * (16 )) + (y * (16)) + oy
		End rem
		 '768/4 = 196
		
		'----------
		'workarround Phillipk: Die findung ist relativ genau (relativ ;) ) - ich machs 100% genau :o)
		Local _x:Int = (((PosX - 30) + ((PosY - 196) * 2) - resXHalf - resYHalf) / (60))
		Local _y:Int = ((-(PosX - 30) + ((PosY - 169) * 2) + resXHalf - resYHalf) / (60))
		
		'Hier das workarrounden: Alle 9 kacheln abgeklappern (errechnete als zentrum) und die screen-zeichenpositionen bestimmen.
		'workaround zum workaround by annixa xD
		Local x:Int, y:Int, dist:Int = 1000, drawX:Int, drawY:Int, tmpDist:Int
		For x = _x - 2 To _x + 2
		For y = _y - 2 To _y + 2
			drawX = (x * 32) - (y * 32) - 64
			drawY = (x * 16) + (y * 16) - 32
			
			tmpDist = MDistf(drawX + 30, drawY + 15, PosX - resXHalf, PosY - resYHalf)
			
			If tmpDist <= dist Then
				mouseTilePosX = x -1
				mouseTilePosY = y
				dist = tmpDist
			EndIf
		Next
		Next
		mousePosXArr = mouseTilePosX + (camX)' - Int(camX))
		mousePosYArr = mouseTilePosY + (camY)' - Int(camY))
			
	'	Print tgame.MSLocal + "mouse"
		
		If hmode = 0'wenn kein "isin" oder "isover" erfolg hatte...
'		
'			If LMD Then
'				addresFX(0, 100, mousePosXArr, mousePosYArr, [255, 0, 255])
'			End If
				
			If tlandschaft.map Then
				Local dings:tbuilding = TLandschaft.map.GetBuilding(mousePosXArr, mousePosYArr)
				If dings Then Tmouse.TTbuffer = tTooltip.Create([dings.Name, "Auswählen"])
				If LMB Then
						
					If dings Then
						SetFocus(dings)
						'tgame.FocusObject = dings
					
						If TTower(dings) Then
							TTower.lastTower = TTower(dings)
						End If
						
					EndIf
				End If
			
				If RMD Then
		
				If SpeedX <> 0 Then
					cam_subx:-SpeedX
					cam_suby:-SpeedX
				End If
				
				If SpeedY <> 0 Then
					cam_subx:-SpeedY * 2
					cam_suby:+SpeedY * 2
				End If
		
				If cam_subx > 60 Then camX:+1;cam_subx = 0
				If cam_subx < - 60 Then camX:-1;cam_subx = 0
				If cam_suby > 60 Then camY:-1;cam_suby = 0
				If cam_suby < - 60 Then camY:+1;cam_suby = 0
		
				TLandschaft.map.Update = 1
				'	DrawSubImageRect(tGui.gfx, PosX:Int - 15, PosY:Int - 15, 31, 31, 0, 18, 31, 31)
				Else
				'	DrawSubImageRect(tGui.gfx, PosX:Int, PosY:Int, 18, 18, hmode * 18, 0, 18, 18)
				EndIf
			EndIf
		Else
		'	DrawSubImageRect(tGui.gfx, PosX:Int, PosY:Int, 18, 18, hmode * 18, 0, 18, 18)
		EndIf
		

		hmode = 0
	End Function
	
	Function Draw()
		If hmode Then
			DrawSubImageRect(tGui.gfx, PosX:Int, PosY:Int, 18, 18, hmode * 18, 0, 18, 18)
		End If
		If RMD Then
			DrawSubImageRect(tGui.gfx, PosX:Int - 15, PosY:Int - 15, 31, 31, 0, 18, 31, 31)
		Else
			DrawSubImageRect(tGui.gfx, PosX:Int, PosY:Int, 18, 18, hmode * 18, 0, 18, 18)
		End If
		
		If TTbuffer Then
			TTbuffer.Draw()
			'ToolTip(TTbuffer.TT_text, TTbuffer.ttsize)
		End If
		
		TTbuffer = Null
		
	End Function
	
'	Function ToolTip(Text:String[], sizeX:Int)
'		ttbuffer.Draw()
'	End Function
	
	'prüft ob die maus sich im bereich start->end befindet 
	Function IsIn:Int(startx:Int, starty:Int, endx:Int, endy:Int)
		If Self.PosX > PosX And Self.PosX < endx
		If Self.PosY > PosY And Self.PosY < endy
			hmode = 1
			Return 1
		End If
		End If
		Return 0
	End Function
	
	'prüft ob maus im bereich pos -> pos+ size ist 
	Function IsOver:Int(posX:Int, posY:Int, Sizex:Int, sizey:Int)
		If Self.posX > posX And Self.posX < posX + Sizex
		If Self.posY > posY And Self.posY < posY + sizey
			hmode = 1
			Return 1
		End If
		End If
		Return 0
	End Function
End Type
