﻿Rem
	tprojectil
	Geplant ists so:
	es gibt ein array mit den verschiedenen projektilen, die weapons haben einen array mit möglichen projektilen welche sie abfeuern können, und ein feld welches das aktuelle
	ausgerüstete projektil indiziert
	beim abfeuern eines schusses wird das tprojectil aus dem array kopiert und mit spezifischen eigenschaften versehen (position,flugrichtung)
	
	author: AnniXa
End Rem

Global dots:TList[4]

dots[0] = CreateList()'void
dots[1] = CreateList()'feuer
dots[2] = CreateList()'gift
dots[3] = CreateList()'eis

Function RegisterDot:Int(id:Int, tuc:tunitcontroller)
	If dots[id].Contains(tuc) Then
		Return 0
	Else
		dots[id].AddLast(tuc)
		Return (1)
	EndIf
End Function

Function UnregisterDOT:Int(id:Int, tuc:tunitcontroller)
	dots[id].Remove(tuc)
End Function

Function CheckDot:Int(id:Int, tuc:tunitcontroller)
	If dots[id].Contains(tuc) Then
		Return 1
	Else
		Return 0
	EndIf
End Function

Type tProjectil Abstract

	Global Projectil:tprojectil[]  'die projektile (werden kopiert beim abfeuern, global-updates wirken sich jedoch direkt auf diese in dem array aus @ alle ab dann abgefeuerten erhalten die)
		
	Global Projectiles:TList = CreateList()
	'position
	Field Posx:Float
	Field posy:Float
	
	'die waffe die das abgefeuert hat
	Field weapon:tweapon
	Field ziel:tunitcontroller
		
	Field speed:Float
	Field icon:Int
	
	Field precision:Int
	Field level:Int
	
	Field maxflew:Float
	
	Field Name:String
	
	Field cost:Int[]
	
	Field sprite:tsprite
	Field SpriteID:Int
			
	Field dmg:Int = 5
	Field dmgScatter:Int = 4
	
	Field VALUEA:Int
	Field VALUEB:Int
	Field VALUEC:Int
	
	Field dotID:Int
	
	Global FeuerFX:Int
	Global smokeFX:Int
	Global slimeFX:Int
	Global exploFX:Int
	Global arkanFX:Int
	Global iceFX:Int
	Global flashFX:Int
	
	Field desc:String[4]

	Global DOTfire:Int
	
	Method OnFire() Abstract
	
	Method Update:Int() Abstract
	
	Method GetSprite(rot:Int)
		Self.sprite = tsprite.Create(0, rot)
	End Method
	
	Method Destroy()
		Projectiles.Remove(Self)
	End Method

	Method CheckSingleDamage:TUnitController()'prüft ob eine unit getroffen wurde
'		Local PdistValue:Int 'hail copy fussili
		
		Local sekx:Int = posx / 8
		Local sekY:Int = posy / 8
		
		Local x:Int, y:Int
		
		For x = sekx - 1 To sekx + 1
			If x < 0 Or x >= TUnitSektor.sX Then Continue
		For y = sekY - 1 To sekY + 1
			If y < 0 Or y >= TUnitSektor.sY Then Continue

'		If sekx < 0 Or sekx >= TUnitSektor.sy Then Return(Null)
'		If sekY < 0 Or sekY >= TUnitSektor.sY Then Return(Null)
			
			For Local ActUnit:TUnitController = EachIn TUnitSektor.sektors[x, y].List 'TUnitController.List
				If ActUnit.isAlive() = 0 Then Continue 'er ist tot, sieh es ein ey- .-
				
				If Self.Posx > (ActUnit.slotX - 0.4 + 0.5) And Self.Posx < (ActUnit.slotX + 0.4 + 0.5) Then
				If Self.posy > (ActUnit.sloty - 0.4 - 0.5) And Self.posy < (ActUnit.sloty + 0.4 - 0.5) Then
					Return ActUnit
				End If
				EndIf
				
			Next
		
		Next
		Next

	End Method
	
	Method applyAOE:Int(aoerange:Float, getroffen:tunitcontroller)'fügt aoe Hinzu, getroffen = die unit welche den pfeil ins gesicht bekommen hat (die hat auch schon schaden bekommen, und muss igno werden)
		Local PdistValue:Int 'hail copy fussili
		Local schaden:Int
	
		Local sekx:Int = getroffen.slotX / 8
		Local sekY:Int = getroffen.sloty / 8
				
		Local x:Int, y:Int
		
		For x = sekx - 1 To sekx + 1
			If x < 0 Or x >= TUnitSektor.sX Then Continue
		For y = sekY - 1 To sekY + 1
			If y < 0 Or y >= TUnitSektor.sY Then Continue

	'	If sekx < 0 Or sekx >= TUnitSektor.sy Then Return(Null)
	'	If sekY < 0 Or sekY >= TUnitSektor.sY Then Return(Null)
			
			For Local ActUnit:TUnitController = EachIn TUnitSektor.sektors[x, y].List 'TUnitController.List
				If ActUnit.isAlive() = 0 Then Continue 'er ist tot, sieh es ein ey- .-
				If ActUnit = getroffen Then Continue 'die wurde schon bearbeitet
				PdistValue = (Sqr ((((ActUnit.slotX + 0.5) - (ActUnit.sloty - 0.5)) ^ 2) + ((getroffen.slotX + 0.5) - (getroffen.sloty - 0.5)) ^ 2))
					'PdistValue = tTarged.pdist(ActUnit.+slotX + 0.5, ActUnit.sloty - 0.5, Self.Posx, Self.posy)
				Print "prüfe..." + PdistValue + "<" + aoerange
					If PdistValue < aoerange 'in reichweite!
					Print "im range!"
						schaden:Int = (Self.dmg + Rand(-dmgScatter, dmgScatter)) * (PdistValue / aoerange)
						Print schaden + " <-- dmg"
						If schaden > 0

							schaden = ActUnit.DoDamage(schaden, Self.weapon.tower)
							'Print "dmg" + schaden
							If schaden > 0 Then
								tEffekt_numbers.Create(schaden, [128, 255, 128], 0, 0, ActUnit.slotX + 0.5, ActUnit.sloty - 0.5, 0.1, 0, 500)
								'ret = 1
								If ActUnit.unit.hp <= 0 Then 'tot
									ActUnit.ACTION = New TUnitAction_die.Create(ActUnit)
									Self.weapon.PushEXP(3, Schaden) 'lasthit = 3exp
								Else
									Self.weapon.PushEXP(1, schaden) 'normalhit = 1exp
								EndIf
							EndIf
						EndIf
					
					EndIf
			Next
		
		Next
		Next

	
	End Method

	Method Copy:tProjectil() Abstract
			
	Function UpdateProjectils()
		'glDisable(GL_TEXTURE_2D)
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
		glBindTexture(GL_TEXTURE_2D, spritetex)
		glColor4f(1, 1, 1, 1)
		
		For Local ActBullet:tProjectil = EachIn Projectiles
			ActBullet.Update()
		Next
		
		glColor4f(1, 1, 1, 1)
	End Function
		
	Function LoadData(file:String) 'geklaut von tunit :> 'ich weiß, meine programmierkunst ist halt geil :) (phillipk*g*)
		If FileType(file) = 0 Then
			RuntimeError("LoadProjectil data Failed -> " + file + " konnte nicht geladen werden: Datei existiert scheinbar einfach garnicht, so als hätte es sie nie gegeben!.")
		End If
		
		Local ini:TInifile = tinifile.Load(file)
		Local Leng:Int
		Local headername:String
		Local weapname:String
		For Local header:TIniheader = EachIn ini.data.Values()
			'sliz0rn
			headername = header.Name
			Leng = Projectil.Length
			Projectil = Projectil[..Leng + 1]
			weapname:String = ini.gets(headername, "name")
			Select weapname 'auswählen welcher typ zu erstellen ist
				Case "Todestrahl"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_todestrahlen
				Case "Einfacher Pfeil"
					Print "erstelle:" + weapname
					Local newpfeil:tprojectil_pfeil = New tprojectil_pfeil
					Projectil[Leng] = newpfeil
				Case "Verbesserter Pfeil"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_pfeil
				Case "Schwerer Pfeil"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_pfeil
				Case "Brandpfeil"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_feuerpfeil
					DOTfire = Leng
				Case "Giftpfeil"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_giftpfeil
				Case "FXsmoke"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXsmoke
					smokeFX = Leng
				Case "FXslime"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXslime
					slimeFX = Leng
				Case "FXexplo"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXexplo
					exploFX = Leng
				Case "FXfire"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXfeuer
					FeuerFX = Leng
				Case "FXarkan"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXarkan
				 	arkanFX = Leng
				Case "FXice"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXice
				 	iceFX = Leng
				Case "FXflash"
					Print "FX:" + weapname
					Projectil[Leng] = New tprojectil_FXflash
				 	flashFX = Leng
				Case "Bolzen"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_bolzen
				Case "3x Bolzen"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_bolzen
				Case "2x Bolzen"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_bolzen
				Case "Metalbolzen"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_Metalbolzen
				Case "Sprengbolzen"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_sprengbolzen
				Case "Steinbrocken"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_kugel
				Case "Eisenkugel"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_kugel
				Case "Böse Eisenkugel"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_kugel				
				Case "Feuerkugel"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_feuerkugel
				Case "Kugelhagel"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_kugel
				Case "Arkan"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_arkan
				Case "Arkaner Schlag"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_arkan
				Case "Arkane Splitter"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_arkan
				Case "Eishauch"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_arkanice
				Case "Blitzschlag"
					Print "erstelle:" + weapname
					Projectil[Leng] = New tprojectil_arkanblitz
				EndSelect
			'eintrag0rn
			Projectil[Leng].dmg = ini.geti(headername, "dmg")
			Projectil[Leng].dmgScatter = ini.geti(headername, "sct")
			Projectil[Leng].speed = ini.geti(headername, "speed")
			Projectil[Leng].Name = weapname
			Projectil[Leng].level = ini.geti(headername, "level")
			Projectil[Leng].DOTid = ini.geti(headername, "dotID")
			Projectil[Leng].icon = ini.geti(headername, "icon")
			Projectil[Leng].VALUEA = ini.geti(headername, "VALUEA")
			Projectil[Leng].cost = ini.getiarray(headername, "cost")
			Projectil[Leng].desc[0] = ini.gets(headername, "desc0")
			Projectil[Leng].desc[1] = ini.gets(headername, "desc1")
			Projectil[Leng].desc[2] = ini.gets(headername, "desc2")
			Projectil[Leng].desc[3] = ini.gets(headername, "desc3")
			Projectil[Leng].VALUEB = ini.geti(headername, "VALUEB")
			Projectil[Leng].VALUEC = ini.geti(headername, "VALUEC")
			If tprojectil_sprengbolzen(Projectil[Leng]) Then
				tprojectil_sprengbolzen(Projectil[Leng]).aoe = ini.geti(headername, "aoe") * 0.001
				Print "waffe hat AOE:" + tprojectil_sprengbolzen(Projectil[Leng]).aoe
			EndIf
			Local spritedata:Int[] = ini.getiarray(headername, "sprite")
			
			For Local ActInt:Int = 0 Until Len (spritedata) Step 4
			'Local actint:Int = 0
			Projectil[Leng].SpriteID = tsprite.AddUV(spritedata[ActInt + 0], spritedata[ActInt + 1], spritedata[ActInt + 2], spritedata[ActInt + 3])'spriteID enthält somit immer den letzten des proj!
			Print "ADDED:" + Projectil[Leng].SpriteID + "for " + weapname
			Next
			
			'print0rn
			Print "Projectilinfo geladen:" + Projectil[Leng].Name + " dmg:" + Projectil[Leng].dmg + " sct:" + Projectil[Leng].dmgScatter
			
		Next
	
	End Function
		
End Type


Type tprojectil_todestrahlen Extends tProjectil
' debug todestrahl (kann man später evtl zu einem musketenschuss oder irgendeine form von magischen strahl umwandeln)
' kanalisierte waffe
	
	Field DmgDealt:Int
	Field LastDMG:Int

	Method OnFire() 'anmerkung: hier ist das projektil bereits kopiert worden!
		'schadenspunkte der waffe addieren:
		Self.dmg:+Self.weapon.dmg
		Self.dmgScatter:+Self.weapon.dmgScatter 'auch den scatter range erhöhen! (mehr max krit, weniger halfmiss dmg)
		tProjectil.Projectiles.AddLast(Self)
	End Method

	Method Update:Int()
		LastDMG = Self.dmg + Rand(-dmgScatter, dmgScatter)
		Self.ziel.DoDamage(LastDMG, Self.weapon.tower)
		DmgDealt:+LastDMG
		If DmgDealt > 30 Then
			tEffekt_numbers.Create(DmgDealt, [0, 170, 0], 10, 0, ziel.slotX, ziel.sloty, 0.1, 0, 500)
			DmgDealt = 0
		EndIf
		
		Draw()
		If Self.ziel.unit.hp <= 0 Then
			Self.ziel.ACTION = New TUnitAction_die.Create(Self.ziel)
			tEffekt_numbers.Create(DmgDealt, [0, 170, 0], 10, 0, ziel.slotX, ziel.sloty, 0.1, 0, 500)
			Self.Destroy()
		EndIf
	End Method

	Method Draw()
		'slotX - camX, sloty - camY
	
		Local uposx:Int = ((ziel.slotX - camx) * (32)) - ((ziel.sloty - camy) * (32)) - 16
		Local uposy:Int = ((ziel.slotX - camx) * (16)) + ((ziel.sloty - camy) * (16))

		Local tposx:Int = ((weapon.tower.Posx - camx) * (32)) - ((weapon.tower.posy - camy) * (32))
		Local tposy:Int = ((weapon.tower.Posx - camx) * (16)) + ((weapon.tower.posy - camy) * (16)) - (weapon.tower.Frame.h * 0.7)
				
		glColor4ub(Rand(63, 255), Rand(0, 0), Rand(189, 0), Rand(128, 255))
		
		glBegin(GL_QUADS)
		
		'	glTexCoord2d(uv[0], uv[1])
			glVertex3d(uposx + 1, uposy + 1, uposy + 1)
			
		'	glTexCoord2d(uv[2], uv[1])
			glVertex3d(uposx - 1, uposy - 1, uposy + 1)
			
			'glTexCoord2d(uv[2], uv[3])
			glVertex3d(tposx + 1, tposy - 1, tposy + 100) 'ka @ zlevel^^
			
		'	glTexCoord2d(uv[0], uv[3])
			glVertex3d(tposx - 1, tposy + 1, tposy + 100)
		glEnd()
	End Method
			
	Method Copy:tProjectil()
		Local newbullet:tprojectil_todestrahlen = New tprojectil_todestrahlen
		newbullet.dmg = Self.dmg
		newbullet.dmgScatter = Self.dmgScatter
		Return(newbullet)
	End Method
End Type
'


'		Posx:+(vX) 'bewegen in vektorrichtung.
'		posy:+(vY)
'		movedX:+(vX)
'		movedY:+(vY)
'		
'		Local x:Int, y:Int
'		
'		GetSlotoffset(Posx, posy, x, y)
'		'Print "----------------------- x: " + x + " y: " + y
'	'	Print "Projektil! Posx: " + Posx + " posy " + posy
'		tEffekt_FloatingText.Create("#", [255, 0, 0], x, y, Posx, posy, 0.1, 0, 3500)
