﻿Rem
	Sorry anni, du kommst nicht ausn puschen. Ich schreibs dann mal :)
End Rem

Rem
	TWave typ. Wird durch mapini gefüllt und verwaltet monstergruppen bzw wellen-anzeiger.
End Rem

Global DEBUG_freeSquad:TUnitSquad = New TUnitSquad

Type TWave
	Global spawnPlace:Int[][]
	Global waves:TWave[] 'hält alle wellen in chronologischer reihenfolge
	Global icons:Int[][] 'hilfsarray zum zeichnen der icons
	
	Global activeWaves:TList = CreateList() 'hält alle 'aktiven' wellen. Für den fall, das eine welle eher gerufen wurde und somit 2 wellen ihre einheiten rotzen.
	
	'ingamerelevantes:
	Field monster:Int[][] ' index1 : anzahl angegebener monsterids, index2: -> 0 -> Monsterid , -> 1 -> anzahl (noch zu spawnen)
	Field posx:Int
	Field posy:Int
	Field sWidth:Int
	Field sHeight:Int
	
	Field levelfaktor:Float = 1.0 'faktor, welches level die units haben.
	
	Field squad:TUnitSquad
	Field squadSize:Int = 1
	
	'gui relevantes:
	Field icon:Int
	Field warningMessage:String
	
	'timing relevantes:
	Field nextMonster:Int 'ms, wann das nächste monster erscheint.
	Field waveRate:Int 'rate, mit die monster erscheinen
	Field _start:Int 'startMS wann die welle loslegt =)
	Field _isActive:Int = 0 '0 für nicht aktiv, -1 für besigt, 1 für aktiv (ist in activeWaves!)
	
	Global nextUpdate:Int = 0 'ms, wann das nächste update der twave sache eintritt.
	Global rebuild:Int = 1000
	
	Function CreateByIni:Twave(ini:TInifile, header:Tiniheader)
		Local wave:twave = New TWave
		
		Local mArray:Int[] = ini.getiArray(header.name, "monster")
		
	'	Print "MONSTER String: " + ini.gets(header.name, "monster")
	'	Print "Len mArray: " + Len(mArray)
	'	Print "inahlt mArray:"
		
	'	For Local i:Int = 0 Until Len(mArray)
	'		Print "index " + i + " + -inahtl : " + mArray[i]
	'	Next
		Local _tmp:Int[]
		
		For Local i:Int = 0 Until Len(mArray) Step 1
			If Not _tmp Then
				_tmp = [mArray[i]]
	'			Print "Monsterid: " + _tmp[0]
			Else
				_tmp:+[mArray[i]]
				wave.monster:+[_tmp]
				_tmp = Null
	'			Print "MonsterAnzahl: " + _tmp[1]
			End If
		'	If Len(marray) > i + 1 Then wave.monster:+[[mArray[i], mArray[i + 1]] ]
		Next
		Local r:Int = Rand(0, Len(Twave.spawnPlace) - 1)
		
		If Len(TWave.spawnPlace) > 0 Then
			wave.posx = TWave.spawnPlace[r][0]
			wave.posy = TWave.spawnPlace[r][1]
		Else
			
			wave.posx = ini.geti(header.name, "posx")
			wave.posy = ini.geti(header.name, "posy")
		End If
		wave.sHeight = ini.geti(header.name, "spawnSizeY", 3)
		wave.sWidth = ini.geti(header.name, "spawnSizeX", 3)
		
		wave._start = ini.geti(header.name, "Delay")
		
		
		
		wave.waveRate = ini.geti(header.name, "UnitRate")
		wave.warningMessage = ini.gets(header.name, "message")
		wave.squadSize = ini.geti(header.name, "squadsize", 1)
		wave.icon = ini.geti(header.name, "icon")
		TWave.waves:+[wave]
	End Function
	
	Function CreateByData:Twave(mArray:Int[], posx:Int, posy:Int, spawnWidth:Int, spawnHeight:Int, addDelay:Int = 0, unitRate:Int = 1000, squadSize:Int = 10, icon:Int = 0, levelFaktor:Float = 1.0)
		Local wave:twave = New TWave
	
		Local _tmp:Int[]
		
		For Local i:Int = 0 Until Len(mArray) Step 1
			If Not _tmp Then
				_tmp = [mArray[i]]
	'			Print "Monsterid: " + _tmp[0]
			Else
				_tmp:+[mArray[i]]
				wave.monster:+[_tmp]
				_tmp = Null
	'			Print "MonsterAnzahl: " + _tmp[1]
			End If
		'	If Len(marray) > i + 1 Then wave.monster:+[[mArray[i], mArray[i + 1]] ]
		Next
		
		Local r:Int = Rand(0, Len(Twave.spawnPlace) - 1)
		
		If Len(TWave.spawnPlace) > 0 Then
			wave.posx = TWave.spawnPlace[r][0]
			wave.posy = TWave.spawnPlace[r][1]
		Else
			
			wave.posx = posx
			wave.posy = posy
		End If
	
		wave.sHeight = 3
		wave.sWidth = 3
		
		Local lastWaveDelay:Int = 0
		
		For Local i:Int = 0 Until Len(waves)
			If waves[i] Then
				If lastWaveDelay < waves[i]._start Then
					lastWaveDelay = waves[i]._start
				End If
			End If
		Next
		
		
		wave._start = addDelay + lastWaveDelay
		
		
		
		wave.waveRate = unitRate
		wave.warningMessage = ""
		wave.squadSize = squadSize
		wave.icon = icon
		wave.levelfaktor = levelfaktor
		TWave.waves:+[wave]
	End Function
	
	Function Update:Int()
		If TGameControl.GameStarted = 0 Then Return 0
		If nextUpdate > tgame.MSLocal Then Return 0
		
		nextUpdate = tgame.MSLocal + 500 - (475 * TGameControl.wavespeedup) 'delay setzen. Deutlich weniger, wenn wavespeedup aktiv ist!
		Local waveCount:Int = 0
		
		rebuild:-(Not TGameControl.wavespeedup)
		
		If rebuild <= 0 Then
			Local l:TList = CreateList()
			
			l.FromArray(waves)
			
			waves = TWave[] (l.ToArray())
			
			Print "Waves wurde 'verkleinert' - länge: " + l.Count()
		End If
		
		For Local aWave:TWave = EachIn activeWaves
		'	Print "update activeWaves"
			If aWave._Update() < 1 Then
		'		Print "aktive wave ist nichtmehr aktiv."
				aWave._isActive = -1
				activeWaves.Remove(aWave)
				For Local i:Int = 0 Until Len(waves)
					If waves[i] = aWave Then
						waves[i] = Null
					End If
				Next
			EndIf
		Next
		For Local naWave:TWave = EachIn waves
		'	Print "update alle waves"
			If naWave._isActive = 0 Then
				waveCount:+1
		'		Print "wave nicht aktiv."
				If naWave._start < tgame.mslocal Then
		'			Print "wave wird aktiv geschaltet."
					tEffekt_WarningText.Create(naWave.warningMessage, [255, 0, 0], 0, 0, 0, 0, 0, 0, 0)
					activeWaves.AddLast(naWave)
					naWave._isActive = 1
					
					If TGameControl.waveSpeedup Then
						TGameControl.waveSpeedup = 0 'es wurde eine welle gespawnt! aufhören mit speedup mode.
					End If
					
				ElseIf TGameControl.waveSpeedup Then
					'speedup!
					naWave._start:-750 'um 10ms verringern, weil speedup! =)
				End If
			End If
		Next
		If waveCount < 3 Then
			TEndlessSpawner.createWave()
		End If
	End Function
	
	Function Draw:Int()
		For Local naWave:TWave = EachIn waves
			If naWave._isActive > - 1 Then
				naWave._draw()
			End If
		Next
	End Function
	Method _draw:Int()
		'Ms differenz feststellen:
		Local diff:Int = _start - tgame.mslocal + ((Not TGameControl.gamestarted) * tgame.stoptime)
		Local x:Int = 50, y:Int = 3
		Local addX:Float = 0, addY:Float = 0
		
		'iterieren, in welchem bereich liegt es:
		If diff <= 1 Then 'es kommt auf sie zu *böse musik
			'nix tun.
		elseIf diff <= 30000 Then '30sek
			addX = 100.0 * (diff / 30000.0)
			
		ElseIf diff <= 60000 Then '60sek
			addX = 100 + 100.0 * ((diff - 30000.0) / 30000.0)
		ElseIf diff <= 180000 Then '180sek
			addX = 200 + 100.0 * ((diff - 60000.0) / 120000.0)
		Else 'der braucht noch =D
			addX:+300
		EndIf
		
		If DrawIcon(x + addX, y) = 1 Then 'mouse ist over!
		'	Tmouse.TTbuffer = twaveTT.Create([0, 1, 0, 1, 0, 1], ["Titel", "Zeile1", "Zeile2", "Zeile3", "Zeile4", "Zeile5", "Zeile6"])
			Local zeilen:String[] = ["Einheitenübersicht"]
			Local icons:Int[]
			
			For Local i:Int = 0 Until Len(monster)
				If monster[i][1] > 0 Then
					Local tuc:Tunit = Tunit.GetByID(monster[i][0])
					
					If tuc Then
						Local icon:Int = 0
						Select tuc.rasse
							Case "Skelett"
								icon = 0
							Case "Ork"
								icon = 1
							Default
								icon = 4
						End Select
					
						zeilen:+[tuc.name + " - " + monster[i][1] + "x"]
						icons:+[icon]
					End If
				End If
			Next
			
			Tmouse.TTbuffer = twaveTT.Create(icons, zeilen)
		EndIf
	End Method
	
	Method _Update:Int()
		'Print "_update! nextMonster: " + nextMonster + " - tgame.mslocal: " + tgame.mslocal
		Local totalCount:Int = 0
		
		If nextMonster < tgame.mslocal Then
			'nächstes monster spawnen!
			
			'schritt 1.1: prüfen obs noch monster gibt.
			Local ids:Int[][]
			For Local i:Int = 0 Until Len(monster)
				If monster[i][1] > 0 Then
					ids:+[[monster[i][0], i]]
					totalCount:+monster[i][1]
			'		Print "Monsterid gefunden:: " + monster[i][0] + " - count verbleibend: " + monster[i][1]
				End If
			Next

			If Len(ids) > 0 Then
			'	Print "ids vorhanden! anzahl möglicher monster: " + Len(ids)
				Local index:Int = Rand(0, Len(ids) - 1)
				
				'squad checken.
				If Not squad Or squad.tuccnt >= squadSize Then
		'			Print "neuer squad wird angelegt."
					squad = New TUnitSquad
				End If
				
				Local px:Int = posx'Min(Tlandschaft.map.sizeX - 3, posx + Rand(0, swidth))
				Local py:Int = posy'Min(Tlandschaft.map.sizeY - 3, posy + Rand(0, sHeight))
				
				Local tuc:TUnitController = TunitController.Create(px, py, ids[index][0], squad, levelfaktor)
				
				monster[ids[index][1]][1]:-1
				
				nextMonster = tgame.MSLocal + waveRate
			
			ElseIf totalCount < 1 Then
			'	Print "totalcount ist 0 - returne 0"
				Return 0
			Else
			'	Print "alle units wurden losgeschickt. returne 0"
				Return 0
			End If
		End If
		Return 1
	End Method
	Method DrawIcon:Int(x:Int, y:Int)
		DrawSubImageRect(tGui.gfx, x + 1, y + 10, 13, 11, 62, 47, 13, 11)
		DrawSubImageRect(tGui.GFX, x, y, 15, 15, TWave.icons[icon][0], TWave.icons[icon][1], TWave.icons[icon][2], TWave.icons[icon][3])
		
		If Tmouse.IsOver(x, y, 15, 16) Then
			SetBlend(LIGHTBLEND)
			DrawSubImageRect(tGui.gfx, x + 1, y + 10, 13, 11, 62, 47, 13, 11)
			DrawSubImageRect(tGui.GFX, x, y, 15, 15, TWave.icons[icon][0], TWave.icons[icon][1], TWave.icons[icon][2], TWave.icons[icon][3])
			SetBlend(ALPHABLEND)
			Return 1
		EndIf
		Return 0
		
	End Method
End Type

Local __x:Int = 76
Local __y:Int = 40
For Local i:Int = 0 Until 12
	TWave.icons:+[[__x, __y, 15, 15]]
	__x:+15
Next

Type TEndlessSpawner
	Global points:Int = 10
	Global lastRace:String = ""
	Global cnt:Int = 0
	
	Global levelfaktor:Float = 1.0
	
	Function createWave:TWave()
		'Rasse entscheiden.
		'ich habe momentan nur: Skelette und Orks
		Local race:String = ""
		Local icon:Int = 0
		Select Rand(0, 1)
			Case 0
				race = "Skelett"
				If race = lastRace Then
					If Rand(0, 10) = 0 Then race = "Ork"
				End If
				icon = 0
			Case 1
				race = "Ork"
				If race = lastRace Then
					If Rand(0, 10) = 0 Then race = "Skelett"
				End If
				icon = 1
		End Select
		
		lastRace = race
		
	'	Print "Rasse gewählt: " + race
		
		Local scale:Float = Rnd(0.8, 1.0)
		Local lf:Float = levelfaktor * scale
		
		Local monster:Int[]
		
		Local possibleUnits:Int[][] 'index - wert
		For Local u:TUnit = EachIn TUnit.list
			If u.rasse = race Then

			
		'		Print "Rasse gefunden: " + u.rasse
				Local punkte:Int = Max(2, Int(u.hp / 30.0)) * Max(Int(u.atk / 2.0), 2)
				
				If punkte <= 0 Then punkte = 1
				possibleUnits:+[[u.id, punkte]]
			End If
		Next
		
		Local punkteToGo:Int = points
		Local ammount:Int = 0
		While 1
			ammount:+1
			Local r:Int = Rand(0, Len(possibleUnits) - 1)
			
			Local mCnt:Int = punkteToGo / possibleUnits[r][1]
			
			Local cnt:Int = Rand(1, mcnt * 2) / 2
			
			
			If cnt > 0 Then
				monster:+[possibleUnits[r][0], cnt]
				punkteToGo:-(possibleUnits[r][1] * cnt)
			endif
			If ammount > 200 Then Exit
			If punkteToGo < 2 Then Exit
		Wend
		
		'monster erstellt.
		'twave draus formen:
		Local x:Int = 0, y:Int = 0
		Select Rand(0, 3)
			Case 0
				'irgendwo oben
				x = Rand(3, TLandschaft.map.sizeX - 4)
				y = 2
			Case 1
				'irgendwo unten
				x = Rand(3, TLandschaft.map.sizeX - 4)
				y = TLandschaft.map.sizeY - 3
			Case 2
				'irgendwo bla1
				'irgendwo unten
				y = Rand(3, TLandschaft.map.sizey - 4)
				x = TLandschaft.map.sizex - 3
			Case 3
				'irgendwo bla2
				'irgendwo unten
				y = Rand(3, TLandschaft.map.sizey - 4)
				x = 2
				
		End Select
		TWave.CreateByData(monster, x, y, 3, 3, Rand(30000, 80000), Rand(500, 2500), Rand(5, 10), icon, lf)
		
		
		'zu guter letzt: Levelskalierung erhöhen.
		levelfaktor:*1.1
		
		TEndlessSpawner.cnt = (TEndlessSpawner.cnt + 1) Mod 5
		If TEndlessSpawner.cnt = 0 Then TEndlessSpawner.points:*1.1
	
	End Function
End Type


'Rem
'	angriffswellen verwaltung
'
'	author: AnniXa
'End Rem
'
'Type tWave'wellen type
'
'	Global Waves:Int[] 'länge des arrays = anzahl der wellen des gesamten levels, inhalt der einträge ist die zeit wann die nächste welle angefordert wird.
'	Global NextWave:Int 'Index der nächsten in den buffer zu packenden welle
'	Global WavesInBuffer:TList 'Liste der wellen,die gerade im puffer sind
'
'	Global Inifile:TInifile
'	Field Speed:Float '"pixel" umd die sich diese angriffswelle pro update weiter bewegt
'	Field Position:Float 'position dieser welle auf dem wellen que
'		
'	Field Spawns:tSpawn[] 'für jeden spawnpunkt auf der map eine tlist mit den einheiten.
'						'die einheiten die spawnen pro welle sollte aus einer .ini gelesen werden würd ich sagen, ala
'						'[Wave15]
'						'ork=5
'						'goblin=2
'						'und dann auf die vorhandenen spawnpunkte der map verteilt werden, so das die gegner bei jedem neustart des spiels aus anderen richtungen bzw anders geordert kommen
'
'		
'	Function Init(levelname:String)
'		'InitialMS = MilliSecs()
'		Inifile = tinifile.Load(levelname + "ini")
'		'todo: wellen aus levelname.ini laden
'		'todo: array durchgehen und tlist (bzw ggf tspawn) erstellen
'	End Function
'	
'	Function Update()
'					
'	End Function
'						
'End Type
'
'Type tSpawn
'	
'	Field Mobs:TList 'liste der mobs die mit diesem spawn spawnen werden / gespawnd sind. (quasi ein squad?)
'	
'End Type